\ EDITFORMFUNCTIONS.FRM		Form to Add Words to Form	DB 2009-0502
\- textbox needs excontrols.f
\- usebitmap needs bitmap.f

MultiLineTextBox MTxtFormNeedsCode
TextBox TxtClassInitCode
TextBox TxtFormInitializedCode
TextBox TxtFormPaintCode         \ added DB 2012-0428
TextBox TxtFormSizeCode          \ added DB 2012-0428
TextBox TxtFormDoneCode
\ PushButton btnFormFuncEdSave   \ removed DB 2012-0226 to cure saving problem
\ PushButton btnFormFuncEdCancel \ removed DB 2012-0226 to cure saving problem

: EditFormFunctionsTitle$ ( -- addr cnt )
                s" Add Words to " new$ dup>r place
                FormTitle: ActiveForm count r@ +place
                r> count ;


:Object frmFormFuncEdit                <Super DialogWindow 

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 
150 175  2value XYPos  \ save screen location of form

\ Font setting definitions

Font Courier-font
: Set-Courier-font ( -- )
                -15          Height: Courier-font
                0             Width: Courier-font
                0        Escapement: Courier-font
                0       Orientation: Courier-font
                400          Weight: Courier-font
                0           CharSet: Courier-font
                3      OutPrecision: Courier-font
                2     ClipPrecision: Courier-font
                1           Quality: Courier-font
                49   PitchAndFamily: Courier-font
                s" Courier New" SetFacename: Courier-font ;

Label lblFormNeedsCode
Label lblClassInitCode
Label lblFormInitializedCode
Label lblFormPaintCode          \ added DB 2012-0428
Label lblFormSizeCode           \ added DB 2012-0428
Label lblFormDoneCode

:M ClassInit:   ( -- )
                ClassInit: super
                \ Insert your code here
                ;M

:M WindowStyle:  ( -- style )
                WS_POPUPWINDOW WS_DLGFRAME or 
                ;M

\ if this form is a modal form a non-zero parent must be set
:M ParentWindow:  ( -- hwndparent | 0 if no parent )
                hWndParent
                ;M

:M SetParentWindow:  ( hwndparent -- ) \ set owner window
                to hWndParent
                ;M

:M WindowTitle: ( -- title )
                EditFormFunctionsTitle$ asciiz ;M

:M StartSize:   ( width height --  )
                358  353  ( 302 with Pushbuttons )
                ;M

:M StartPos:    ( -- x y )
                XYPos
                ;M

:M Close:        ( -- )
                \ Insert your code here
                Close: super
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor

                self Start: lblFormNeedsCode
                9 8 302 11 Move: lblFormNeedsCode
                Handle: Winfont SetFont: lblFormNeedsCode
                s" This Form needs:" SetText: lblFormNeedsCode

                self Start: MTxtFormNeedsCode
                10 25 340 100 Move: MTxtFormNeedsCode
                Set-Courier-font
                Create: Courier-font
                Handle: Courier-font SetFont: MTxtFormNeedsCode

                self Start: lblClassInitCode
                9 130 302 14 Move: lblClassInitCode
                Handle: Winfont SetFont: lblClassInitCode
                s" Words to execute before Initialization of Form:" SetText: lblClassInitCode

                self Start: TxtClassInitCode
                10 148 340 20 Move: TxtClassInitCode
                Set-Courier-font
                Handle: Courier-font SetFont: TxtClassInitCode

                self Start: lblFormInitializedCode
                9 172 302 14 Move: lblFormInitializedCode
                Handle: Winfont SetFont: lblFormInitializedCode
                s" Words to execute when Form is initialized:" SetText: lblFormInitializedCode

                self Start: TxtFormInitializedCode
                10 190 340 20 Move: TxtFormInitializedCode
                Set-Courier-font
                Handle: Courier-font SetFont: TxtFormInitializedCode

                self Start: lblFormPaintCode          \ DB added 2012-0428
                9 214 302 17 Move: lblFormPaintCode
                Handle: Winfont SetFont: lblFormPaintCode
                s" Words to execute on painting:" SetText: lblFormPaintCode

                self Start: TxtFormPaintCode          \ DB added 2012-0428
                10 232 340 20 Move: TxtFormPaintCode
                Set-Courier-font
                Handle: Courier-font SetFont: TxtFormPaintCode

                self Start: lblFormSizeCode          \ DB added 2012-0428
                9 256 302 17 Move: lblFormSizeCode
                Handle: Winfont SetFont: lblFormSizeCode
                s" Words to execute on sizing:" SetText: lblFormSizeCode

                self Start: TxtFormSizeCode          \ DB added 2012-0428
                10 274 340 20 Move: TxtFormSizeCode
                Set-Courier-font
                Handle: Courier-font SetFont: TxtFormSizeCode

                self Start: lblFormDoneCode
                9 298 302 11 Move: lblFormDoneCode
                Handle: Winfont SetFont: lblFormDoneCode
                s" Words to execute when done:" SetText: lblFormDoneCode

                self Start: TxtFormDoneCode
                10 316 340 20 Move: TxtFormDoneCode
                Set-Courier-font
                Handle: Courier-font SetFont: TxtFormDoneCode
comment:
                self Start: btnFormFuncEdSave
                11 260 89 30 Move: btnFormFuncEdSave
                Handle: Winfont SetFont: btnFormFuncEdSave
                s" Save Words to Execute with Form" ToolString: btnFormFuncEdSave
                s" &Apply" SetText: btnFormFuncEdSave

                self Start: btnFormFuncEdCancel
                260 259 90 32 Move: btnFormFuncEdCancel
                Handle: Winfont SetFont: btnFormFuncEdCancel
                s" Close without Saving Form-Words" ToolString: btnFormFuncEdCancel
                s" &Close" SetText: btnFormFuncEdCancel
comment;
                ParentWindow: self   \ if this is a modal form disable parent
                if   0 ParentWindow: self Call EnableWindow drop then
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont
                Delete: Courier-font
                originx originy 2to XYPos
                ParentWindow: self   \ if modal form re-enable parent
                if   1 ParentWindow: self Call EnableWindow drop
                     \ reset focus to parent if we have one
                     ParentWindow: self Call SetFocus drop
                then
                \ Insert your code here
                On_Done: super
                ;M

;Object

comment:			\ defined in FORMPROPERTY.F
: SaveEditFormCode   ( -- )
	SaveProperties: frmEditForm
;

 ' SaveEditFormCode SetFunc: btnFormFuncEdSave
comment;

: CloseEditFormCode  ( -- ) 
Close:  frmFormFuncEdit
; 

\ ' CloseEditFormCode SetFunc: btnFormFuncEdCancel


