\ Form and control editing

cr .( Loading FormProperty.f Form and control editing...)

load-bitmap savebmp1 "save1.bmp"
load-bitmap savebmp2 "save2.bmp"
load-bitmap stopbmp1 "stop1.bmp"
load-bitmap stopbmp2 "stop2.bmp"

: Txt>Bitmap-Text ( a n -- )		\ for Arrays Bitmap Cloning DB 2009-0501
	maxbitmap min Bitmap-Text 2dup c! 1+ swap cmove
;

: GetBitmap     ( -- )
                Gethandle: frmEditProperties Start: GetBitmapDlg dup c@
                if      count RemoveCurrentPath 2dup Txt>Bitmap-Text SetText: txtBitmap	\ added Txt>Bitmap-Text for Arrays Bitmap Cloning DB 2009-0501
                else    drop
                then    ; ' GetBitmap SetFunc: btnBrowse

: GetMenuBar    ( -- )                  \ DB 2012-0414
                Gethandle: frmEditFormProperties Start: GetMenuBarDlg dup c@
                if      count RemoveCurrentPath SetText: TxtMenuBarFile
                else    drop
                then    ; ' GetMenuBar SetFunc: BtnMenuBarFile


0 value eActiveControl
0 value eActiveForm    \ current form, not necessarily the ActiveForm

: IsTypeButton? { \ ctrltype -- f }
                GetType: eActiveControl to ctrltype
                ctrlType TypePushbutton    =  ?dup ?exit
                ctrlType TypeGroupBox      =  ?dup ?exit
                ctrlType TypeCheckBox      =  ?dup ?exit
                ctrlType TypeRadioButton   =  ?dup ?exit
                ctrlType TypeMultiLineBox  =  ?dup ?exit
                ctrlType TypeScrollTextBox =  ?dup ?exit
                ctrlType TypeLabel         =  ;

: CheckTypeText ( -- f )
\ Justification is invalid for some controls so we disable this feature if the control
\ is a textbox, listbox or combobox
                GetType: eActiveControl
                |  TypeTextBox
                   TypeListBox
                   TypeComboBox
                   TypeComboListBox
                   TypeHorizScroll
                   TypeVertScroll
                   TypeMultiListBox
                   TypeFileWindow
                   TypeTabControl
                   TypeDrawBox
                |if   false
                else  true
                then  dup Enable: radLeft
                dup Enable: radCenter
                dup Enable: radRight
      \          dup Enable: radLefttext
                dup Enable: grpOrientation ;
               
: ?EnableSpinner        ( -- )
                        GetType: eActiveControl TypeTextBox = 
                         dup Enable: chkSpinner
                         dup Enable: RadSpinnerMin
                         dup Enable: RadSpinnerMax
                        if       Spinner?: eActiveControl
                                 GetSpinnerMinMax: eActiveControl
                                 SetValue: RadSpinnerMax SetValue: RadSpinnerMin
                        else     false
                        then     Check: chkSpinner ;

\ Additions for Function-Edit 2008-07-12/14 DB

: ?FunctionEmpty   ( -- flag )  \ true if no Function-Name saved
                GetFunction: eActiveControl ?dup
                        if   0 do dup I + C@ BL = not if drop 0 leave then loop
                        then     ;

: ?EnableFuncEdit ( -- )        \ Editing will be enabled if there is a Function-Name
                Disable: btnFuncEdit
                ?FunctionEmpty 0=
                        if   true Enable: btnFuncEdit then  ;

: SetEdFunctionTxt ( -- )    \ set title for Editfunction.frm
                GetFunction: eActiveControl SetText: txtEdFunction
;

: LoadEdFunctionTxt ( -- )
                GetEdFunction: eActiveControl SetText: MtxtFunction
                GetRequirements: eActiveControl SetText: MTxtRequirements
;

: EditFunction ( -- )        \ open Editfunction.frm 
                Start: frmFuncEdit
                SetEdFunctionTxt LoadEdFunctionTxt
;

' EditFunction SetFunc: btnFuncEdit

: ?EdFunctionEmpty   ( -- flag )  \ true if empty
                GetEdFunction: eActiveControl nip ;

: Txt>EdFunction-Text ( a n -- )
	maxEdFunction min EdFunction-Text 2dup c! 1+ swap cmove
;

: Txt>Requirements-Text ( a n -- )
	maxRequirements min Requirements-Text 2dup c! 1+ swap cmove
;

: SaveEdFunctionTxt ( -- )
                GetText: MtxtFunction 2dup Txt>EdFunction-Text dup 2 TooManyCharsMessage
		IsEdFunction: eActiveControl
                GetText: MTxtRequirements 2dup Txt>Requirements-Text dup 3 TooManyCharsMessage 
		IsRequirements: eActiveControl
                IsModified: ActiveForm   \ to be sure Function will be saved
;

' SaveEdFunctionTxt SetFunc: btnFuncEdSave

\ End Additions for Function-Edit 


: GetObject# ( adress len -- adress len )    \ GetObject#  added for arrays etc. DB 2009-0316
\ gets Number after last alpha char
   2dup >r dup r> 0 do over i + c@ ascii 0 ascii 9 1+ within 0=
			if drop dup i + 1+ then loop nip
   dup >r rot - ( difference between old and new address ) - ( new length )
   r> swap
;


: LoadProperties        ( -- )
                GetName:  eActiveControl 2dup GetObject# SetText: TxtControl# SetText: txtName	\ TxtControl# added for arrays etc. DB 2009-0316
                GetTitle: eActiveControl SetText: txtCaption
                Origin: eActiveControl SetValue: spnYpos SetValue: spnXpos
                Dimensions: eActiveControl SetValue: spnHeight SetValue: spnWidth
                GetFunction: eActiveControl SetText: txtFunction \ to type in a word for execution  2008-07-08 DB
                GetToolTip: eActiveControl SetText: txtToolTip
                GetBitmap: eActiveControl SetText: txtBitmap
                Disable: txtBitmap       \ default
                Disable: btnBrowse       \ ,,
                Disable: btnFuncEdit
                Group?: eActiveControl Check: chkGroup
                Global?: eActiveControl Check: chkGlobal
                ?EnableSpinner
                GetType: eActiveControl dup
                TypeBitmapButton = swap TypeStaticBitmap = or
                if      Disable: radLeft
                        Disable: radCenter
                        Disable: radRight
          \              Disable: radLefttext
                        Disable: grpOrientation
                        true Enable: txtBitmap
                        true Enable: btnBrowse
                else    \ first clear any previous orientation selection
                        UnCheckButton: radLeft
                        UnCheckButton: radCenter
                        UnCheckButton: radRight
          \              UnCheckButton: radLeftText
                        CheckTypeText     \ if it is a valid control
                        if  Orientation: eActiveControl
                            case
                                    0       of      CheckButton: radLeft     endof
                                    1       of      CheckButton: radCenter   endof
                                    2       of      CheckButton: radRight    endof
                        \            3       of      CheckButton: radLefttext endof
                            endcase
                        then    GetType: eActiveControl dup TypeCheckBox <>
                        swap TypeRadioButton <> and
                        if   \   Disable: radLeftText     \ not valid for this control
                        then
                then    ?EnableFuncEdit ;		\ Addition for Function-Edit 2008-07-12/14 DB


: Txt>Function-Text ( a n -- )				\ Addition for Function-Edit 2008-07-12/14 DB
	maxFunction min Function-Text 2dup c! 1+ swap cmove
;

: GetSpinnerMinMax  ( -- n )
    GetValue: RadSpinnerMin 65535 and
    GetValue: RadSpinnerMax 65535 and 65536 * +
;

: SaveProperties        { \ x y w h -- }
                eActiveForm ?FormNumber 0= ?exit    \ form no longer exists
                eActiveControl ?ControlNumber: eActiveForm 0= ?exit
                Origin: eActiveControl to y to x
                Dimensions: eActiveControl to h to w
                GetText: txtName 2dup GetObject# SetText: TxtControl# SetName: eActiveControl	\ TxtControl# added for arrays etc. DB 2009-0316
                GetText: txtCaption SetTitle: eActiveControl
                GetValue: spnXpos  GetValue: spnYpos SetOrigin: eActiveControl
                GetValue: spnWidth GetValue: spnHeight 2dup to ControlHeigth to ControlWidth SetDimensions: eActiveControl	\ 2dup to ... added for Cloning DB 2009-0501
                GetText: txtFunction 2dup Txt>Function-Text	\ added DB 2009-0318
		IsFunction: eActiveControl   \ to type in a word for execution  2008-07-08 DB
                GetText: txtTooltip IsTooltip: eActiveControl
                GetType: eActiveControl dup
                TypeBitmapButton = swap TypeStaticBitmap = or
                if      GetText: txtBitmap IsBitmap: eActiveControl
                then    IsButtonChecked?: chkGroup IsGroup: eActiveControl
                IsButtonChecked?: chkGlobal IsGlobal: eActiveControl
                GetType: eActiveControl TypeTextBox =
                if       IsButtonChecked?: chkSpinner dup IsSpinner: eActiveControl
                         if   GetSpinnerMinMax IsSpinnerMinMax: eActiveControl
                         then 
                then
                \ justification
                IsTypeButton?
                if      IsButtonChecked?: radLeft
                        if      0
                        else    IsButtonChecked?: radCenter
                                if      1
                                else    IsButtonChecked?: radRight
                                        if      2
comment:
                                        else    IsButtonChecked?: radLeftText
                                                if      3
                                                then
comment;
                                        then
                                then
                        then    IsOrientation: eActiveControl
                then    Validate: eActiveForm           \ update
                Ismodified: eActiveForm                 \ and check
                Update: eActiveControl                  \ everything
                UpdateStatus: eActiveForm               \ at this time
                Paint: eActiveForm ;                    \ and refresh display

: initload      ( -- )
                ActiveControl: ActiveForm to eActiveControl
                ActiveForm to eActiveForm
                eActiveControl 0= ?exit
                LoadProperties  \ initialize form
                ;

: doPrevious    ( -- )  \ cycle through controls in current form
                ActiveForm 0= ?exit
                Locked?: ActiveForm ?exit
                #Controls: ActiveForm 0= ?exit
                ActiveControl: ActiveForm ?dup
                if      ?ControlNumber: ActiveForm
                else    1
                then    dup 0=
                if      drop exit       \ no control list
                then    1- 1 max        \ go to previous control
\		dup (.) SetText: TxtControl#	\ TxtControl# added for arrays etc. DB 2009-0310
                ControlList: ActiveForm dup>r >Link#: [ ]
                r> Data@: [ ] SetActiveControl: ActiveForm
                Paint: ActiveForm
                UpdateStatus: ActiveForm
                UpdatePropertyWindow ;

: doNext        ( -- ) \ cycle through controls in current form
                ActiveForm 0= ?exit
                Locked?: ActiveForm ?exit
                #Controls: ActiveForm 0= ?exit
                ActiveControl: ActiveForm ?dup
                if      ?ControlNumber: ActiveForm
                else    1
                then    dup 0=
                if      drop exit       \ no control list
                then    1+ #Controls: ActiveForm min        \ go to next control
\		dup (.) SetText: TxtControl#	\ TxtControl# added for arrays etc. DB 2009-0310
                ControlList: ActiveForm dup>r >Link#: [ ]
                r> Data@: [ ] SetActiveControl: ActiveForm
                Paint: ActiveForm
                UpdateStatus: ActiveForm
                UpdatePropertyWindow ;

: PropertyFunc  ( h m w l id obj -- h m w l )
                { cid obj -- }
                cid     \ control id
                case
                                 IDOK     of      SaveProperties   endof
                                 GetID: btnPrevious
                                          of      doPrevious       endof
                                 GetID: btnNext
                                          of      doNext           endof
                                 IDCANCEL of      Close: obj       endof
                                 endcase ;

:Noname         ( -- )
                frmEditProperties.hwnd 0= ?exit    \ window  is not open
\ Remove comment from the following if you will need to save the properties first
\ If you do and you are just browsing controls the form(s) will be marked as
\ modified even though you haven't made any changes.

\                SaveProperties          \ save first
                initload                \ reload for new control
                ; is UpDatePropertyWindow

:Object frmEditForm                <Super frmEditFormProperties

:M LoadProperties:        ( -- )
                 FormName: ActiveForm count SetText: txtName
                FormTitle: ActiveForm count SetText: txtTitle
              FormMenuBar: ActiveForm count SetText: txtMenuBarFile     \ DB 2012-0414
	FormNeedsFunction: ActiveForm count SetText: MTxtFormNeedsCode 	\ DB 2009-0527
	 FormInitFunction: ActiveForm count SetText: TxtClassInitCode 	\ DB 2009-0502
	FormInitializedFunction: ActiveForm count SetText: TxtFormInitializedCode 	\ DB 2009-0502
	FormPaintFunction: ActiveForm count SetText: TxtFormPaintCode 	\ DB 2012-0428
	 FormSizeFunction: ActiveForm count SetText: TxtFormSizeCode 	\ DB 2012-0428
	 FormDoneFunction: ActiveForm count SetText: TxtFormDoneCode 	\ DB 2009-0502
                   Origin: ActiveForm  SetValue: spnYpos
                                       SetValue: spnXpos
               Dimensions: ActiveForm  SetValue: spnHeight
                                       SetValue: spnWidth
                   GetModal: ActiveForm Check: ChkModal
                SaveScreen?: ActiveForm Check: chkSave
                 ChildState: ActiveForm Check: chkChildState
                   MenuBar?: ActiveForm Check: chkMenuBar
                 StatusBar?: ActiveForm Check: chkStatusBar
               Interpreter?: ActiveForm Check: chkInterpreter     \ DB 2012-0511
              GetSuperClass: ActiveForm
                case
                        CHILD-CLASS     of  CheckButton: radChildWindow
                                            UnCheckButton: radMDIDialogWindow
                                            UnCheckButton: radDialogWindow
                                            UnCheckButton: radSuperWindow
                                            true Enable: chkChildState
                                        endof
                        MDIDIALOG-CLASS of  CheckButton: radMdiDialogWindow
                                            UnCheckButton: radChildWindow
                                            UnCheckButton: radDialogWindow
                                            UnCheckButton: radSuperWindow
                                            false Enable: chkChildState
                                        endof
                        DIALOG-CLASS    of  CheckButton: radDialogWindow    
                                            UnCheckButton: radSuperWindow
                                            UnCheckButton: radMDIDialogWindow
                                            UnCheckButton: radChildWindow
                                            false Enable: chkChildState
                                        endof
                                            CheckButton: radSuperWindow     \ default \ added DB 2012-0407
                                            UnCheckButton: radDialogWindow
                                            UnCheckButton: radMDIDialogWindow
                                            UnCheckButton: radChildWindow
                                            false Enable: chkChildState
                endcase ;M

:M SaveProperties:   { \ x y w h -- }
                Origin: ActiveForm to y to x
                Dimensions: ActiveForm to h to w
                GetText: txtName   IsFormName: ActiveForm
                GetText: txtTitle  IsFormTitle: ActiveForm
                GetText: txtMenuBarFile  IsFormMenuBar: ActiveForm              \ DB 2012-0414
		GetText: MTxtFormNeedsCode IsFormNeedsFunction: ActiveForm 	\ DB 2009-0527
		GetText: TxtClassInitCode   IsFormInitFunction:  ActiveForm 	\ DB 2009-0503
		GetText: TxtFormInitializedCode IsFormInitializedFunction: ActiveForm 	\ DB 2009-0503
		GetText: TxtFormPaintCode  IsFormPaintFunction:  ActiveForm 	\ DB 2012-0428
		GetText: TxtFormSizeCode    IsFormSizeFunction:  ActiveForm 	\ DB 2012-0428
		GetText: TxtFormDoneCode    IsFormDoneFunction:  ActiveForm 	\ DB 2009-0503
                GetValue: spnXpos  GetValue: spnYpos SetOrigin:  ActiveForm
                GetValue: spnWidth GetValue: spnHeight SetDimensions: ActiveForm
                IsButtonChecked?: chkModal SetModal: ActiveForm
                IsButtonChecked?: chkSave IsSaveScreen?: ActiveForm
                IsButtonChecked?: chkChildState IsChildState: ActiveForm
                IsButtonChecked?: chkMenuBar IsMenuBar: ActiveForm
                IsButtonChecked?: chkStatusBar IsStatusBar: ActiveForm
                IsButtonChecked?: chkInterpreter IsInterpreter: ActiveForm      \ DB 2012-0511
                IsButtonChecked?: radDialogWindow
                if  DIALOG-CLASS
                else    IsButtonChecked?: radChildWindow
                        if  CHILD-CLASS
                        else    IsButtonChecked?: radSuperWindow
                                if    SUPER-CLASS
                                else  MDIDIALOG-CLASS
                        then    then
                then    IsSuperClass: ActiveForm
                0 0 Dimensions: ActiveForm        ( x y w h )
                SetRect: TempRect
                0                                       \ no menu
                WindowStyle: ActiveForm                 \ the window style
                AddrOf: TempRect                         \ make a new rectangle
                Call AdjustWindowRect ?win-error        \ adjust the window
                Right: TempRect Left: TempRect -         \ adjusted  width
                Bottom: TempRect  Top: TempRect -         \ adjusted height
                GetHandle: ActiveForm AdjustWindowSize
                FormTitle: ActiveForm count Settext: ActiveForm
                Validate: ActiveForm  \ check everything is ok
                IsModified: ActiveForm
                DoUpdate
                Refresh: ActiveForm ;M

: FormFunc      ( h m w l id obj -- res )
                drop ( ID )
                case
                        GetId: radDialogWindow      of      Disable: chkChildState      endof
                        GetId: radSuperWindow       of      Disable: chkChildState      endof \ added DB 2012-0407
                        GetId: radChildWindow       of      true Enable: chkChildState  endof
                        GetId: radMDIDialogWindow   of      Disable: chkChildState      endof
                endcase ;

:M On_Init:        ( -- )
                On_Init: super

                ['] Formfunc SetCommand: self

                LoadProperties: self

                ;M

;Object

:Object frmProperties++                <Super frmPropertiesWindow
imagebutton btnapply
imagebutton btnclose

: ontab         { l obj -- }
                GetSelectedTab: obj
                case
                        0       of      Hide: frmEditProperties
                                        Hide: frmAction
                                        Display: frmEditForm            endof
                        1       of      Hide: frmEditForm
                                        Hide: frmAction
                                        Display: frmEditProperties      endof
                        2       of      Hide: frmEditProperties
                                        Hide: frmEditForm
                                        Display: frmAction              endof
                endcase LoadProperties: frmEditForm ;

: ?apply        ( -- )
                Locked?: ActiveForm ?exitm
                GetSelectedTab: TabProperties
                case
                        0       of      SaveProperties: frmEditForm     endof
                        1       of      SaveProperties  ?EnableFuncEdit  endof  ( control )	\ Addition for Function-Edit 2008-07-12/14 DB
                endcase ;
                
:M Close:       ( -- )
                Close: frmEditForm
                Close: frmEditProperties
                Close: frmAction
		Close: frmFormFuncEdit		\ added DB 2009 0709 - closes only with closing form
		Close: frmFuncEdit		\ added DB 2009 0709 - dito
                Close: Super ;M

: frmcommand    ( h m w l id obj -- res )
                drop ( ID )
                case
                        IDOK     of     ?apply           	endof
                        IDCANCEL of     Close: self      
					Close: frmFormFuncEdit		\ added DB 2009 0709 - closes with closing self
					Close: frmFuncEdit	endof	\ added DB 2009 0709 - dito
                endcase ;

:M On_Init:     ( -- )

                IDOK SetId: btnApply
                IDCANCEL SetID: btnClose
                
                TCS_BUTTONS AddStyle: TabProperties

                On_Init: Super
                
                self Start: btnApply
                btnApplyX btnApplyY btnApplyW btnApplyH Move: btnApply
                savebmp2 usebitmap map-3DColors
                savebmp2 setimage: btnapply             \ normal displayed image
                savebmp1 usebitmap map-3DColors
                savebmp1 SetImage#2: btnApply      \ image to display when hovering mouse
                s" Apply" SetText: btnApply
                Handle: WinFont SetFont: btnApply
                
                self Start: btnClose
                btnCloseX btnCloseY btnCloseW btnCloseH Move: btnClose
                stopbmp2 usebitmap map-3DColors
                stopbmp2 setimage: btnclose             \ normal displayed image
                stopbmp1 usebitmap map-3DColors         \ image to display when hovering mouse
                stopbmp1 SetImage#2: btnClose
                s" Close" SetText: btnClose
                Handle: WinFont SetFont: btnClose


                ['] ontab IsChangeFunc: TabProperties

                ['] frmcommand SetCommand: self

                z" Form" IsPsztext: TabProperties
                TCIF_TEXT IsMask: TabProperties
                0 InsertTab: TabProperties

                z" Control" IsPsztext: TabProperties
                TCIF_TEXT IsMask: TabProperties
                1 InsertTab: TabProperties

                z" Action" IsPsztext: TabProperties
                TCIF_TEXT IsMask: TabProperties
                2 InsertTab: TabProperties

                Addr: TabProperties Start: frmEditForm
                ClientSize: TabProperties 2over d- Move: frmEditForm

                ['] PropertyFunc SetCommand: frmEditProperties
                Addr: TabProperties Start: frmEditProperties
                ClientSize: TabProperties 2over d- Move: frmEditProperties

                Addr: TabProperties Start: frmAction
                ClientSize: TabProperties 2over d- Move: frmAction

                ;M

:M ShowTab:     ( n -- )
                SetSelectedTab: TabProperties
                0 Addr: TabProperties ontab
                ;M
                
:M ClassInit:   ( -- )
                ClassInit: Super
                self link-formwindow
                ;M

;Object

: UpdateProperties++    ( -- )
                GetHandle: frmProperties++ 0= ?exit
                LoadProperties: frmEditForm     \ and update
                ;

:Noname         ( -- )   \ edit form properties
                ActiveForm 0= ?exit
                GetHandle: TheMainWindow SetParentWindow: frmProperties++
                Start: frmProperties++
                0 ShowTab: frmProperties++      \ show the form tab
                UpdateProperties++ ; is doForm

:Noname         ( -- )   \ edit control properties
                ActiveForm 0= ?exit
                GetHandle: TheMainWindow SetParentWindow: frmProperties++
                Start: frmProperties++
                1 ShowTab: frmProperties++      \ show the control tab
                initload ; is doEdit

:Noname         ( -- )   \ multiple action on controls
                ActiveForm 0= ?exit
                GetHandle: TheMainWindow SetParentWindow: frmProperties++
                Start: frmProperties++
                2 ShowTab: frmProperties++      \ show the action tab
                ; is doGroupAction

: SaveEditFormCode   ( -- )			\ DB 2009-0503
                GetText: MTxtFormNeedsCode dup 4 TooManyCharsMessage IsFormNeedsFunction: ActiveForm
                GetText: TxtClassInitCode dup 1 TooManyCharsMessage   IsFormInitFunction: ActiveForm
		GetText: TxtFormInitializedCode dup 1 TooManyCharsMessage IsFormInitializedFunction:  ActiveForm
		GetText: TxtFormPaintCode dup 1 TooManyCharsMessage  IsFormPaintFunction: ActiveForm \ added DB 2012-0428
		GetText: TxtFormSizeCode  dup 1 TooManyCharsMessage   IsFormSizeFunction: ActiveForm \ added DB 2012-0428 
		GetText: TxtFormDoneCode  dup 1 TooManyCharsMessage   IsFormDoneFunction: ActiveForm 
                IsModified: ActiveForm   \ to be sure Function will be saved
           \     DoUpdate          \ removed DB 2012-0226 - Solving problem by Closing Properties+
           \     UpdateSystem      \ removed DB 2012-0226 - Solving problem by Closing Properties+
;

\ ' SaveEditFormCode SetFunc: btnFormFuncEdSave	\ DB 2009-0503 \ removed 2012-0226 to cure saving problem
\s
