\ GraphicTools.f - from Windemo.f  DB 2010-0522

( only ) forth also definitions


\ ---------------------------------------------------------------
\       Define the BIT-WINDOW global drawing functions
\ ---------------------------------------------------------------

needs DrawBox.f

: Yellow! LtYellow LineColor: drawbox-dc ;
: Red! LtRed LineColor: drawbox-dc ;
: Blue! LtBlue LineColor: drawbox-dc ;
: Green! LtGreen LineColor: drawbox-dc ;
: Black! Black LineColor: drawbox-dc ;
: White! White LineColor: drawbox-dc ;


  2 value bit-originx
  2 value bit-originy
  0 value LINE-VALUE
  0 value line-count

-1 value prev-x
-1 value prev-y

: moveto        ( x y -- )
                0max screen-height 4 - min swap 0max screen-width 4 - min swap
                bit-originy + swap bit-originx +  swap
                over prev-x = over prev-y = and
                IF      2drop
                ELSE    2dup to prev-y
                             to prev-x
                        2dup PrinterMoveTo: ThePrinter
                                    MoveTo: drawbox-dc
                THEN    ;

: lineto        ( x y -- )
                0max screen-height 4 - min swap 0max screen-width 4 - min swap
                bit-originy + swap bit-originx +  swap
                over prev-x = over prev-y = and
                IF      2drop
                ELSE    2dup to prev-y
                             to prev-x
                        2dup PrinterLineTo: ThePrinter
                                    LineTo: drawbox-dc
                then
                1 +to line-count ;

: line          ( x1 y1 x2 y2 -- )
                2swap moveto lineto ;

: line-color    ( color_object -- )
                ?ColorCheck
                dup to line-value
                dup
                case    black   of white        endof
                        white   of black        endof
                        yellow  of blue         endof
                                   dup
                endcase PrinterLineColor: ThePrinter
                               LineColor: drawbox-dc ;

: Frame         ( -- ) \ needs Paint: DrawBox-App to appear
                0 0 SCREEN-MWIDTH 0 line 
                SCREEN-MWIDTH SCREEN-MHEIGHT lineto  
                0 SCREEN-MHEIGHT lineto  
                0 0 lineto ;
comment:
: uninit-demo   ( -- )
                DestroyWindow: DEMOW ;

unload-chain chain-add-before uninit-demo
comment;




\ ---------------------------------------------------------------
\               Actual application section for DEMO
\ ---------------------------------------------------------------


ColorObject TheNextColor

: next-color    ( -- )
                BLACK line-color        \ make sure that TheNextColor object
                                        \ is not selected into the DC
                256 random 1+           \ before trying to create a new color
                256 random 1+
                256 random 1+ rgb
                NewColor: TheNextColor
                          TheNextColor line-color ;

: erase-drawbox    ( -- )
                0 0 screen-width screen-height WHITE PrinterFillArea: ThePrinter
                0 0 screen-width screen-height WHITE        FillArea: drawbox-dc
                0 to line-count ;



\s

\ ---------------------------------------------------------------
\               Printing support
\ ---------------------------------------------------------------

  0 value VGA-X                 \ VGA x coordinate in pixels
  0 value VGA-Y                 \ VGA y coordinate in pixels
  0 value walking?
  0 value save-count
  0 value do-printing?


defer save-bitmap
' noop is save-bitmap

0 value SEED1-SAVE
0 value SEED2-SAVE
0 value SEED3-SAVE


: print-demo    ( -- )
                TRUE to do-printing?
                seed1-save to seed1     \ print same as displayed
                seed2-save to seed2
                seed3-save to seed3
                200 TO line_max
                400 TO lines_max
                0 TO line_limit
                0 TO cnt-down
                3 TO cnt-down-max
                single-page
                start-scaled
                IF      erase-demo
                        S" Printing DEMO..." "demo-message
                        walking?
                        IF      line-walk
                        ELSE    run-demo
                        THEN
                        print-scaled
                        demo-message-off
                THEN
                FALSE to do-printing? ;

: print-demo-bmp { nBits \  pbmi lpBits hbm  hdcMem    -- }
             Open: ThePrinter
        GetHandle: ThePrinter 0= ?EXIT
            Start: ThePrinter

             sizeof(BitmapInfoHeader) sizeof(RGBQUAD) 256 * + malloc to pbmi
        pbmi sizeof(BitmapInfoHeader) sizeof(RGBQUAD) 256 * + erase   \ (1) DON'T DELETE THIS LINE
                                                                      \

        sizeof(BitmapInfoHeader)                   pbmi biSize            + !
        SCREEN-WIDTH                               pbmi biWidth           + !
        SCREEN-HEIGHT                              pbmi biHeight          + !
        1                                          pbmi biPlanes          + w!
        nBits                                      pbmi biBitCount        + w!

        BI_RGB                                     pbmi biCompression     + !

      \  0    pbmi biSizeImage       +   !       NOT NEEDED           (1)
      \  0    pbmi biXPelsPerMeter   +   !       SINCE
      \  0    pbmi biYPelsPerMeter   +   !       pbmi IS ERASED
      \  0    pbmi biClrUsed         +   !       ABOVE
      \  0    pbmi biClrImportant    +   !


        SCREEN-HEIGHT
        SCREEN-WIDTH
        GetHandle: drawbox-dc
        Call CreateCompatibleBitmap to hbm


        GetHandle: drawbox-dc
        Call CreateCompatibleDC to hdcMem
        hbm hdcMem Call SelectObject drop

        SRCCOPY                                   \
        0 0                                       \ y,x origin
        GetHandle: drawbox-dc                        \ from screen dc
        SCREEN-HEIGHT                             \ height of dest rect
        SCREEN-WIDTH                              \ width of dest rect
        0 0                                       \ y,x dest
        hdcMem                                    \ to memory dc
        Call BitBlt ?win-error                    \


        DIB_RGB_COLORS
        pbmi
        NULL
        SCREEN-HEIGHT
        0
        hbm
        hdcMem
        Call GetDIBits 0= abort" 1st GetDIBits"


       \ pbmi show-bitmapinfoheader

        pbmi biSizeImage + @ malloc to lpBits
        lpBits pbmi biSizeImage + @ erase


        DIB_RGB_COLORS
        pbmi
        lpBits
        SCREEN-HEIGHT
        0
        hbm
        hdcMem
        Call GetDIBits 0= abort" 2nd GetDIBits"

      \  pbmi show-bitmapinfoheader


        SRCCOPY
        DIB_RGB_COLORS
        pbmi
        lpBits

        SCREEN-HEIGHT
        SCREEN-WIDTH
        0
        0
        Height: ThePrinter
        Width: ThePrinter
        0
        0
        GetHandle: ThePrinter
        Call StretchDIBits GDI_ERROR = ABORT" StretchDIBits"
          End: ThePrinter
        Close: ThePrinter
        hdcMem call DeleteDC ?win-error
        hbm call DeleteObject ?win-error


        lpBits release
        pbmi release
        ;


 