(( ForthForm.F  A Free Form Designer for Win32Forth by Ezra Boyce
Written to simplify the design of forms with user design classes of controls.
The generated file can be saved as a forth form file (.frm), pasted into one's
program and modified as needed or be accessed somewhat like Windows dialogs.
))

anew -ForthForm.f

 : sysgen ;
\ : withbgnd ;
\ add the ForthForm folder's to our path list
\ September 20th, 2003 - 9:57 dbu
s" apps\visualFORTH"     "fpath+
s" apps\visualFORTH\res" "fpath+

only forth also definitions

vocabulary forthform
vocabulary testvocab       \ for testing forms to avoid conflicts
forthform also definitions

false value turnkey?				 \ DB 2009-0309
\ 58 Value ZoomDefault \ For Screen Resolution 800x600 pixels \ DB 2013-0815
78 Value ZoomDefault  \ For Screen Resolution 1024x768 pixels \ DB 2013-0815
variable Standalone				 \ DB 2009-0404	\ on for using NoConsole
Standalone off					 \ DB 2010-0606	\ off is default
Variable TimeStamp                               \ DB 2012-0122
TimeStamp on                                     \ DB 2012-0122 \ off is default
Variable with-multistatusbar                     \ DB 2013-0104
with-multistatusbar on                           \ DB 2013-0104 \ off is default 
Variable ActiveFormName   32 allot		 \ DB 2009-0309
Variable CompiledFormName 32 allot		 \ DB 2009-0309

 40 constant FormFunctionMax 	\ to type in words for execution with Form \ DB 2009-0502  
128 constant FormNeedsMax 	\ to type in words needed with Form 	   \ DB 2009-0528  
 32 constant maxFunction 	\ to type in a word for execution  	2008-07-08 DB
128 constant maxEdFunction   	\ words for Function execution  	2008-07-12 DB
128 constant maxRequirements 	\ words for Requirements execution  	2008-07-14 DB
100 constant maxbitmap 	        \ placed here from Formcontrols.f	DB 2009-0611
variable Function-Text maxFunction allot	 \ DB 2009-0318
variable EdFunction-Text maxEdFunction allot	 \ DB 2009-0318
variable Requirements-Text maxRequirements allot \ DB 2009-0611	\ for cloning in Arrays
variable Bitmap-Text maxbitmap allot		 \ DB 2009-0501	\ for cloning Bitmap in Arrays
0 value ControlWidth				 \ dito
0 value ControlHeigth				 \ dito
0 value ActiveCtrl				 \ DB 2009-0504 for Editfunction-Title

\ for W32F 6.14	from ExUtils.f old etc. DB 10-0605

-1 value WM_WIN32FORTH                          \ w32f
\ *G This windows message definition for WM_WIN32FORTH, provides a way for
\ ** multiple Win32Forth applications to interact between themselves
\ ** while running.

defer win32forth-message

\ changed September 6th, 2003 - 17:30 dbu
7 proc SendMessageTimeout
: _win32forth-message ( lParam wParam -- )      \ w32f intern
        2>R 0 SP@ 2 ( ms ) SMTO_ABORTIFHUNG 2R>
        WM_WIN32FORTH HWND_BROADCAST Call SendMessageTimeout 2drop ;

' _win32forth-message is win32forth-message ( lParam wParam -- ) \ w32f
\ *G WIN32FORTH-MESSAGE allows a unique message to be broadcast to all
\ ** currently running instances of Win32Forth.
\ *P 'wParam' is the application specific sub-message that each instance can
\ *P ** use to determine if it should handle the message.
\ ** 'lParam' is available to pass specific information between instances
\ ** of Win32Forth.
\ *P Note: The message is not only broadcast to to all currently running
\ ** instances of Win32Forth. It is brodcast to ALL windows in the system.
\ ** So it may be rather slow...

comment:
The following routines uses shared memory for interprocess communication. Uses
the last 1k for info passing, arbitrarily reserving the first 24 bytes for
process ids. First cell will identify visualFORTH. Second cell identifies Project Manager.
comment;

newproc FF_ACTIVATE  \ sent on startup
newproc WANT_FORMS   \ request forms
newproc FORMS_SENT   \ acknowledge

comment:

0 value ed-ptr
1024 constant msg-buff-len
msg-buff-len  6 cells - constant param-max

4096 ( + 4096 / 4096 * ) constant ed-size   \ multiples of 4k bytes - from editor_io.f old


ed-size msg-buff-len - constant msg-offset  \ start of message buffer for visualFORTH
102378530 constant FFormID              \ identify visualFORTH
872015346 constant ProMgrID             \ identify Project Manager
0 value msg-buffer                      \ pointer to buffer, set at runtime
0 value param-buffer

: init-msg-buffer  ( -- )
                  ed-ptr ?dup
                  if    msg-offset + to msg-buffer   \ run time initialization
                        msg-buffer [ 6 cells ] LITERAL + to param-buffer
                  then  ;

Initialization-chain Chain-add init-msg-buffer
init-msg-buffer

: ?vF-started   ( -- f )
                   msg-buffer FFormID = ;

: vF-started    ( f -- )
                   if         FFormID
                   else       0
                   then       msg-buffer ;
comment;

comment:

: ?promgr-started ( -- f )
                   msg-buffer cell+ @ ProMgrID = ;

: promgr-started   ( f -- )
                   if         ProMgrID
                   else       0
                   then       msg-buffer cell+ ! ;
comment;

\ end of for W32F form ExUtils.f old

needs excontrols.f          \ extended controls for Win32Forth
needs ExUtils.f             \ general utilities
needs w_search.f
needs linklist.f            \ very useful utility
needs bitmap.f              \ bitmap loading routines
needs point.f               \ simple point class
needs rect.f                \ class for drawing boxes
needs fcases.f              \ case extensions
needs file.f                \ file functions encapsulated in a class
needs caseEx.f              \ extension to case and if
needs joinstr.f             \ join any number of counted strings
needs toolbar.f             \ Windows toolbar class
needs enum.f                \ enumerated constants
needs multiopen.f           \ open multiple forms
needs rebarcontrol.f        \ allow enhanced toolbar
needs HtmlControl.f         \ for viewing the help file
needs ScintillaControl.f    \ editor for FormPad
needs FileLister.f          \ directory viewer
needs DrawBox.f             \ to convert to drawbox \ DB 2012-0113
needs Win32Help.f
needs Resources.f

\+ withbgnd needs imagewindow.f   \ utility to allow viewing of different image formats

\ control identifiers
1 to enum-value
enum:      TypeLabel        TypeTextBox      TypeGroupBox      TypePushButton
           TypeCheckBox     TypeRadioButton  TypeBitMapButton  TypeIconButton
           TypeMultiLineBox TypeStaticBitmap TypeUpDownControl
           TypeProgressBar  TypeTrackBar     TypeListBox       TypeComboBox
           TypeComboListBox TypeRadioBar     TypeStatusBar     TypeCalendar
           TypeHorizScroll  TypeVertScroll   TypeMultiListBox  TypePictureButton
           TypeGeneric      TypeFileWindow   TypeTabControl    TypeSpinnerControl
           TypeDrawBox      TypeScrollTextBox
           ;

\ class identifiers
0 to enum-value
enum:
    DIALOG-CLASS
    SUPER-CLASS
    CHILD-CLASS
    MDIDIALOG-CLASS ;

\ identifiers for toolbar alignment
0 to enum-value
enum:
     TOP
     LEFT
     BOTTOM
     RIGHT ;

top value align_rebar \ default
0 value RebarHeight
0 value RebarWidth
create rebar$ 0 , 8 allot	\ order of controls in rebar, room for expansion

10 constant gridspacing         \ pixels between grid points

0 value ActiveForm    \ current form
0 value ThisForm
0 value TheMainWindow  \ allow forward referencing
0 value FormList        \ pointer to list of open forms
0 value formcount       \ running total of created forms
0 value ButtonID        \ button to be unchecked
0 value DrawBoxID        \ defer for IDC_DRAWBOX DB 2010-0521
0 value lastType	 \ last selected Type - used for changeControl DB 2009-0413
0 value TheControlToolBar
0 value TheMainToolBar
0 value NextControlType    \ next control to be created
GRAY value BackGroundColor   \ default
false value newcontrol?
0 value statuswindow            \ pointer to status window object
0 value inconsole
0 value picturebmp
0 value staticbmp
\ registry values
100 value WindowTop                 \ main window y position
100 value WindowLeft                \ main window x position
600 value WindowWidth               \ main window width
400 value WindowHeight              \ main window height
536 value MonitorLeft               \ monitor window x position
375 value MonitorTop                \ default is same y position
true value FlatToolBar?             \ do we want a flat toolbar ?
false value ButtonText?             \ display button text ?, actually disabled
true value ShowMonitor?             \ display  the window positioning monitor
false value ShowConsole?             \ display  Console 2008-07-14 DB
false value Zooming?                \ zooming off 2010-0503 DB
0 value frmdata-size                \ set to values for checking a form
0 value ctrldata-size               \ before opening it
true value show-notes?		    \ display release notes on startup?
false value one-click?		    \ allow one control to be added at a time?

variable formwindow-link            \ all forthform windows, allow simple closing
         formwindow-link off

WM_USER 256 + constant FF_PASTE     \ message to tell Win32forth to paste source text

ColorObject FormColor             \ background form color
Font ControlFont                  \ default font for text to be written in control

\+ withbgnd FreeImageWindow BkGndImageWindow  \ create instance
File MergeFile
File TheFile

\ adapted from WinEd
061505 constant vF_version#  \ DB 2018-0428 Update to W10 W32F 6.15.04
\ 061504 constant vF_version#  \ DB 2017-1120 Update to W10 W32F 6.15.04
\ 021419 constant vF_version#  \ DB 2013-0905 Update for visualFORTH.org
\ 000119 constant vF_version#  \ DB 2013-0725 Zooming set to 80%
\ 000118 constant vF_version#  \ DB 2013-0702 <Super Window added
\ 000117 constant vF_version#  \ DB 2013-0104 MultiStatusbar added
\ 000116 constant vF_version#  \ DB 2012-0422 ScrollTextBox added
\ 000115 constant vF_version#  \ DB 2010-0521 DrawBox added
\ 011414 constant vF_version#  \ DB 2009-1121 Local Controls added
\ 000112 constant vF_version#  \ DB 2009-0702  Bitmap handles etc. generated automatically, added needed to Forth-files and Form-files automatically 
\ 000111 constant vF_version#  \ DB 2009-0619  Help automatically changing to German
\ 000110 constant vF_version#  \ DB 2009-0611  Array-Function compiling minimized
\ 000109 constant vF_version#  \ DB 2009-0609 enhanced Bitmap-Handling, Bitmaps integrated into EXE
\ 000108 constant vF_version#  \ DB 2009-0528 Some minor corrections and enhancements
\ 000107 constant vF_version#  \ DB 2009-0502 Groupdelete added, Form Functions added
\ 000106 2009-03-31 DB \ 2.02.08 with additions/changes DB 2008-10-05
\ parts of wishlist done - DB 2009-03-02	\ 0.01.05 added I/O redirection, "Forth, added Tooltips DB 2009-04-12
\ 0.01.06 Arrays reorganized - DB 2009-0424
\ Version numbers: v.ww.rr
\
\ v   Major version -  0: Test Status 1: First public Release
\ ww  Minor version - 01: Alpha 02: Beta
\ rr  Release
\
\ Odd minor version numbers are possibly unstable beta releases.

: ForthFormTitle$ ( -- addr cnt )
                s" VisualFORTH " new$ dup>r place
                vF_version# ((version)) r@ +place
                r> count ;

: ExitOnError   ( f -- )
                S" A serious error has occurred in VisualFORTH!" ?TerminateBox ;

macro ?abort " if abort then"

\ define defer functions

defer doNew
defer doOpen
defer doSave
defer doSaveAs
defer doDelete
defer doCopy
defer doCopyControlListConsole		\ DB 2009-0430
defer doCopyControlListClipboard	\ DB 2009-0430
defer doCopyFunctionListConsole		\ DB 2009-0502
defer doCopyFunctionListClipboard	\ DB 2009-0502
defer doWrite
defer doTest
defer OnActive
defer doExit
defer doPref
defer doAbout
defer doEdit
defer doForm
defer doForth
defer doForthConsole
defer doEditor
defer doTurnkey
defer doTabOrder
defer doFormHelp
defer doUpdate
defer doSaveSession  \ save the current state of the system to a file
defer doLoadsession  \ reload a saved state
defer doCloseAllForms
defer doCloseForm
defer doSaveAll
defer doMoveToBack
defer doMoveToFront
defer UpdatePropertyWindow
defer domerge
defer doGroupAction
defer doCreateToolBar
defer doSplitter
defer doCreateMenu
defer UpdateSystem
defer (OpenForm)
defer doPropertyForm
defer SwitchToSelect	\ added to use it in this file DB 2009-0319
defer DisableArray	\ added to use it in this file DB 2009-0430
defer doDeleteControls	\ added DB 2009-0501

: link-formwindow { win -- }
                formwindow-link link,    \ link into list
                win , ;

: close-windows  { \ wlink -- } \ close ForthForm windows
                formwindow-link @
                begin   dup
                while   dup cell+ @ to wlink
                        Close: wlink
                        @
                repeat  drop ;

\+ withbgnd BkGndImageWindow link-formwindow  \ link

: Start-Win32ForthIDE   ( -- )  \ start  the editor if not already started
                     editor-present?
			if      s" Win32Forth*IDE" "SetToForeground drop
			else    s" Win32ForthIDE.exe" PrePend<Home>\
				conhndl ExecuteFile
			then  ;

: ffLoadProject   	( -- )       \ start the project manager if not started
                     s" Win32for.exe" PrePend<Home>\
                     temp$ place  s"  LoadProject" temp$ +place temp$
                     exec-cmd drop ;

: Start-ProjectManager   ( -- )       \ start the project manager if not started
Comment:
                     ?promgr-started ?exit
                     s" Project.exe" PrePend<Home>\
                     GetHandle: TheMainWindow ExecuteFile 
comment;
;

: set-base-path   ( -- )
                PROGREG-SET-BASE-PATH
                s" ForthForm\" PROGREG +place  \ set the base registry string
                ;

: "GetDefaultValue ( addr n -- n1 flag ) \ read a value from registry
        GetSetting dup
        if      number? >r d>s r>
        else    2drop 0 false
        then    ;

: ShowPosition  { x y -- } \ display coordinates in status window
                join$(   s" X= "
			 x >str
			 s"    "
			 s" Y= "
			 y (.)
                )join$ 1+ 1 SetText: statuswindow ;

: ShowSize      { w h -- }  \ display dimensions in status window
                join$(	s" Width= "
			w >str
			s"   "
			s" Height= "
			h (.)
                )join$ 1+ 2 SetText: statuswindow ;

: ShowConsole	( -- )		\ DB 2009-0502
	ShowConsole? not if doForth true to ShowConsole? then
;

: ClearStatusWindow  ( -- )   \ clear status window duh!
                z" " 0 SetText: statuswindow
                z" " 1 SetText: statuswindow
                z" " 2 SetText: statuswindow
                z" " 3 SetText: statuswindow
                z" " 4 SetText: statuswindow ;

: AdjustWindowSize      { width height winhndl -- }
               [ SWP_SHOWWINDOW SWP_NOZORDER or SWP_NOMOVE or ] LITERAL
                height width
                0 0     \ ignore position
                0       \ ignore z-order
                winhndl Call SetWindowPos drop ;

: ALignGridXY   ( -- )
                ActiveForm 0= ?exit
                AlignGridXY: ActiveForm ;

: ALignGridX    ( -- )
                ActiveForm 0= ?exit
                AlignGridX: ActiveForm ;

: ALignGridY    ( -- )
                ActiveForm 0= ?exit
                AlignGridY: ActiveForm ;

: AutoSize      ( -- )
                ActiveForm 0= ?exit
                AutoSize: ActiveForm ;

: ArrangeVertical ( -- )
                ActiveForm 0= ?exit
                ArrangeVertical: ActiveForm ;

: ArrangeHorizontal ( -- )
                ActiveForm 0= ?exit
                ArrangeHorizontal: ActiveForm ;

:NoName         ( -- )
                ActiveForm 0= ?exit
                DeleteControl: ActiveForm ; is doDelete

:NoName         ( -- )
                ActiveForm 0= ?exit
                DeleteControls: ActiveForm ; is doDeleteControls

:NoName         ( -- )
                ActiveForm 0= ?exit
                MoveToBack: ActiveForm ;  is doMoveToBack

:NoName         ( -- )
                ActiveForm 0= ?exit
                MoveToFront: ActiveForm ; is doMoveToFront

: ChangeControl ( -- )  \ change current control to new selection
		lastType if true to newcontrol? then	\ added to compensate SwitchToSelect DB 2009-0414
                newcontrol? 0= ?exit    \ must select from toolbar
                ActiveForm  0= ?exit    \ for obvious reasons
                ActiveControl: Activeform 0= ?exit
                ChangeControl: ActiveForm ;

: ChangeToDrawBox ( -- )  \ change current control to DrawBox  DB 2010-0521
                DrawBoxID to ButtonID 
                TypeDrawBox dup to NextControlType to lastType
		true to newcontrol?	\ added to compensate SwitchToSelect DB 2009-0414
                ActiveForm  0= ?exit    \ for obvious reasons
                ActiveControl: Activeform 0= ?exit
                ChangeToDrawBox: ActiveForm ;

: ChangeToScrollTextBox ( -- )  \ change current control to ScrollTextBox  DB 2012-0422
       \         ScrollTextBoxID to ButtonID 
                TypeScrollTextBox dup to NextControlType to lastType
		true to newcontrol?	\ added to compensate SwitchToSelect DB 2009-0414
                ActiveForm  0= ?exit    \ for obvious reasons
                ActiveControl: Activeform 0= ?exit
                ChangeToScrollTextBox: ActiveForm ;

: CopyControl ( -- )  \ copy current control		\ DB 2009-04
                ActiveForm  0= ?exit    \ for obvious reasons
                ActiveControl: Activeform 0= ?exit
                CopyControl:   ActiveForm ;

: ChangeControlFont  ( -- )    \ change the font for a control
                ActiveForm 0= ?exit
                ActiveControl: ActiveForm ?dup
                if    GetUserFont: [ ]
                      IsModified: ActiveForm
                then  ;

: ResetControlFont   ( -- )       \ reset control to the default
                ActiveForm 0= ?exit
                ActiveControl: ActiveForm ?dup
                if    DefaultFont: [ ]
                      IsModified: ActiveForm
                then  ;

: #Forms        ( -- n )    \ return number of open forms
                FormList
                if      Data@: FormList
                        if      #Links: FormList
                        else    0
                        then
                else    0
                then    ;

: ?FormNumber   { frmobject -- n } \ given object address return position in list
                frmobject 0= FormList 0= or
                if      0 exit
                then    >FirstLink: FormList
                #Forms 1+ 1
                ?do     Data@: FormList frmobject =
                        if     i unloop
                               exit
                        then   >NextLink: FormList
                loop    0 ;

: lType dup 0< 0= if 0 do dup i + c@ emit loop else drop then drop ;		\ added to type TheBuffer	\ DB 2009 0611

\ Additions to remove current path	DB 2009-0505

: (count) ( adress n -- n )
\ counts chars of string beginning at adress until zero or ctrl
   0 swap 0 do over i + c@ 31 > if 1+ else leave then loop swap drop
; 

: \Filename ( adress n -- adress n )     \ gets Filename after last "\"
   >r dup r> dup >r 0 do over i + c@ ascii \ = if drop dup i + 1+ then 
                         over i + c@ ascii . = 
			 if leave then loop nip dup r> (count)
;

: Get-FilePath ( adress1 n1 -- adress n ) \ adress1 n1 of Filename with Path
	2dup \Filename drop nip over - 1-
;

: RemoveCurrentPath ( adr len -- adr len ) \ Removes Path if File is in the Current Path
	2dup Get-FilePath current-dir$ count ISTR=
		if  \Filename then
;

\ Special Messages			DB 2009-0506

: TooManyCharsMessage ( n sel -- )	\ sel - selects max
	case 1 of FormFunctionMax 2 - endof
	     2 of maxEdFunction   1-  endof
	     3 of maxRequirements 1-  endof
	     4 of FormNeedsMax    2 - endof
	2drop
	endcase > s" Too many Characters!" ?MessageBox 
;

FileOpenDialog OpenSessionDlg "Load Session File" "Session Files|*.ses|"
FileSaveDialog SaveSessionDlg "Save Session File" "Session Files|*.ses|"
MultiFileOpenDialog OpenFormDlg "Open Form File" "Form Files|*.ff|All Files|*.*|"
FileSaveDialog SaveFormDlg "Save Form File" "Form Files|*.ff|"
FileOpenDialog GetBitmapDlg "Get Bitmap" "Bitmap Files|*.bmp;*.dib|"
FileOpenDialog GetMenuBarDlg "Get MenuBar File" "MenuBar Files|*.mdf|"       \ DB 2012-0414

needs forms.frm             \ all ForthForm dialogs
needs formpad.f             \ mini code editor
needs formhelp.f            \ html help for using ForthForm
needs formtoolbar.f         \ customizable toolbar definitions
needs formmenu.f            \ deliver coffee... yeah right!
needs formcontrols.f        \ subclassed control object
needs groupaction.f         \ positioning of controls
needs formobject.f          \ load form class
needs about.f               \ about dialog
needs taborder.f            \ change tab order form
needs formproperty.f        \ edit of form properties
needs CreateToolBar.f       \ toolbar generator ...but you knew that right?
needs SplitterWindow.f      \ this is also an easy guess!
needs CreateMenu.f          \ now what could this file be for?
needs CreatePropertyForm.f  \ generate property sheet like template
needs formmonitor.f         \ monitor window for positioning forms
needs TEXTBOXEMIT.f         \ needed to end visualFORTH


Form DummyForm
ControlObject DummyControl

: UpdateFormPicker  ( -- )  \ update combolist control
                GetHandle: FormPicker 0= ?exit
                Clear: FormPicker
                #Forms ?dup
                if      1+ 1
                        ?do     i >Link#: FormList
                                Data@: FormList FormName: [ ]
                                count asciiz AddStringTo: FormPicker
                        loop    ActiveForm ?dup
                        if      ?FormNumber 1- 0max SetSelection: FormPicker
                        then
                then    ;

: updatewin     ( -- )      \ update everything
                UpdateFormPicker
                UpdateProperties++
                ShowMonitor?
                if          Update: Monitor
                then    ; ' updatewin is doupdate

/* ******************** Specialised words for ForthForm.cfg ************** */
#IFDEF withbgnd
create BkGndImage$ 0 , max-path allot-to         \ for user supplied BackGroundImage

\ put this command in the ForthForm.cfg file to change the default BackGroundImage
: SetBackGroundImage  ( <file> -- )   \ get file name from input stream
\in-system-ok   also forthform
                /parse-word count ?dup
                if      BkGndImage$ place
                else    drop
\in-system-ok   then    previous ;
' SetBackGroundImage alias SetWallpaper  \ for compatibility
#ENDIF
/* ************************************************************************* */

: SaveRebar    ( -- )
		align_rebar 1 and \ left or right
		if 	width: therebar
		else 	0
		then 	to rebarwidth
		align_rebar 1 and 0= \ top or bottom
		if 	height: therebar
		else 	0
		then 	to rebarheight ;

: SaveDefaults  ( -- ) \ save default information in registry
                decimal

                set-base-path
		SaveRebar

                OriginX: TheMainWindow s>d (d.) s" WindowLeft"          SetSetting
                OriginY: TheMainWindow s>d (d.) s" WindowTop"           SetSetting
                GetHandle: TheMainWindow Call IsIconic 0=   \ if window is not minimised
                if      Width: TheMainWindow s>d (d.) s" WindowWidth"   SetSetting
                       Height: TheMainWindow s>d (d.) s" WindowHeight"  SetSetting
                then    ShowMonitor?
                if      Monitor.OriginX        s>d (d.) s" MonitorLeft" SetSetting
                        Monitor.OriginY        s>d (d.) s" MonitorTop"  SetSetting
                then
\+ withbgnd     ImageFileName: BkGndImageWindow s" BackGroundImage"     SetSetting
                FlatToolbar?           s>d (d.) s" ToolbarStyle"        SetSetting
                ShowMonitor?           s>d (d.) s" ShowMonitor"         SetSetting
                ShowConsole?           s>d (d.) s" ShowConsole"         SetSetting
                align_rebar            s>d (d.) s" AlignRebar"          SetSetting
		RebarHeight	       s>d (d.) s" RebarHeight"         SetSetting
		RebarWidth             s>d (d.) s" RebarWidth"          SetSetting
		GetOrder: TheRebar		s" RebarOrder"          SetSetting
                show-notes?            s>d (d.) s" ShowNotes"           SetSetting
                Zooming?               s>d (d.) s" Zooming"             SetSetting
                ;

: LoadDefaults  ( -- )  \ load values from registry
                decimal
                s" WindowLeft"     "GetDefaultValue if to WindowLeft     else drop then
                s" WindowTop"      "GetDefaultValue if to WindowTop      else drop then
                s" WindowWidth"    "GetDefaultValue if to WindowWidth    else drop then
                s" WindowHeight"   "GetDefaultValue if to WindowHeight   else drop then
                s" MonitorLeft"    "GetDefaultValue if to MonitorLeft    else drop then
                s" MonitorTop"     "GetDefaultValue if to MonitorTop     else drop then
\+ withbgnd     s" BackGroundImage" GetSetting ?dup if BkGndImage$ place else drop then
                s" ToolbarStyle"   "GetDefaultValue if to FlatToolBar?   else drop then
                s" ShowMonitor"    "GetDefaultValue if to ShowMonitor?   else drop then
                s" ShowConsole"    "GetDefaultValue if to ShowConsole?   else drop then
                s" AlignRebar"     "GetDefaultValue if to align_rebar    else drop then
		s" RebarHeight"    "GetDefaultValue if to RebarHeight    else drop then
		s" RebarWidth"     "GetDefaultValue if to RebarWidth     else drop then
		s" RebarOrder"     GetSetting ?dup  if rebar$ place      else drop then
                s" ShowNotes"      "GetDefaultValue if to show-notes?    else drop then
                s" Zooming"        "GetDefaultValue if dup to Zooming? 
                                                              Zooming !  else drop then
                ;

: check-file      { fname fcnt \ fsize -- f }      \ check integrity of file before opening
                  fname fcnt SetName: TheFile   \
                  Open: TheFile ?dup ?exit
                  FileSize: TheFile drop to fsize  \ larger than 4 gig .ff file?
                  Close: TheFile
                  fsize GetData: DummyForm nip  < ?dup ?exit   \ must have at least a form header
                  fsize GetData: DummyForm nip  - GetData: DummyControl nip mod 0<>  \ must be evenly divisible
                  ;

:NoName         ( -- )      \ _NewForm
                AddNewForm
                Init: ThisForm
                s" untitled.ff" SetFileName: ThisForm
                join$(  s" Form"
			formcount (.)
		)join$ count 2dup  SetName: ThisForm
                               IsFormTitle: ThisForm
		\ Clearing Add Words		\ DB 2009 0610
		s" " IsFormMenuBar: ThisForm    \ DB 2012-0414
		s" " IsFormNeedsFunction: ThisForm
		s" " IsFormInitFunction:  ThisForm
		s" " IsFormInitializedFunction: ThisForm
		s" " IsFormPaintFunction: ThisForm  \ added DB 2012-0428
		s" " IsFormSizeFunction:  ThisForm  \ added DB 2012-0428
		s" " IsFormDoneFunction:  ThisForm
                Start: ThisForm
                Display: ThisForm
                doupdate ;  is doNew

:NoName         { fname fcnt -- } \ open form given its name
                fname fcnt check-file ?dup
                if    join$(    fname fcnt
				s"  is an invalid VisualFORTH file!"
		      )join$  count ?MessageBox
                      exit
                then  AddNewForm
                Start: ThisForm
                fname fcnt SetFileName: ThisForm
                Load: ThisForm
                Display: ThisForm
                doupdate
                UpdateSystem ; is (OpenForm)

:NoName         ( -- ) \ open one or more form files
                GetHandle: TheMainWindow Start: OpenFormDlg c@
                if      #SelectedFiles: OpenFormDlg 0
                        do      i GetFile: OpenFormDlg (OpenForm)
                        loop
                then    ;    is doOpen

:NoName         ( -- )     \ view/edit form
                ActiveForm 0= ?exit
                GetBuffer: ActiveForm FormName: ActiveForm count ShowSource ; is doEditor

: strip-cmdline ( addr cnt -- addr2 cnt2 )
                [CHAR] " skip [CHAR] ' skip BL skip
                [CHAR] " -TRAILCHARS [CHAR] ' -TRAILCHARS BL -TRAILCHARS ;

: OpenByExtension { addr cnt -- }
                  addr cnt ".ext-only" pad place pad uppercase
                  case	s" .FF"		"of	addr cnt (OpenForm)	endof
			s" .TDF"	"of	addr cnt LoadToolBarFile: frmCreateToolBar
									endof
			s" .MDF"	"of	addr cnt doCreateMenu Load: TheMenu
									endof
			s" .SES"	"of	addr cnt temp$ place
						nostack1 temp$ ['] $fload catch
						s" Session load aborted!" ?MessageBox
									endof
		  endcase ;

: HandleCmdLine ( -- ) \ open the Form given via command line (November 8th, 2003 - 9:52 - dbu)
                CMDLINE ?dup
                if   \ get command line address and length
                     strip-cmdline
                     \ and open the file
                     OpenByExtension
                else drop
                then ;

:NoName         ( -- )  \ just save form, allow name change if untitled
                ActiveForm 0= ?exit
                Save: ActiveForm ;  is doSave

:NoName         ( -- )  \ save under different name
                ActiveForm 0= ?exit
                SaveAs: ActiveForm ;  is doSaveAs

:NoName         ( -- )  \ compile to disk
		DisableArray		\ added for convenience DB 2009-0319-0430
                ActiveForm
                if      CompileForm: ActiveForm
                then    ;  is doWrite

: (doTest)  ( -- ) \ test form from image in memory - changed for turnkey purposes DB 2009-0307
	DisableArray		\ added for convenience DB 2009-0319-0430
        ActiveForm 0= ?exit
        Validate: ActiveForm
        s" anew _frm" evaluate
        ChildState: ActiveForm >r      \ we want to see the form if it is a child, so we
        false IsChildState: Activeform \ save the state and change in case it is hidden
        GetBuffer: ActiveForm 2drop
        fload-buffer                        \ load actual form
        GetSuperClass: ActiveForm dup CHILD-CLASS =     \ compiling as a child window?
        if      drop TestChildDialog: ActiveForm fload-buffer
        else    MDIDIALOG-CLASS =               \ or as a MDI dialog?
            if      TestMDIDialog: ActiveForm fload-buffer
            else    s" Start: " new$ dup>r place FormName: ActiveForm count r@ +place   \ no, as a dialog window
                    r> count evaluate
            then
        then    r> IsChildState: ActiveForm ;  

:NoName  ( -- ) \ test form from image in memory	\ for turnkey purposes DB 2009-0307
   (doTest) ; is doTest

:NoName  ( -- ) \ make .exe-file from image in memory	\ for turnkey purposes DB 2009-0307
	ActiveForm 	
	if   Turnkey: ActiveForm
	else true s" No active Form selected!" ?MessageBox 
	then ; is doTurnkey

:NoName         ( -- ) \ save all modified forms
                #Forms ?dup
                if      1+ 1
                        do      i >Link#: FormList
                                Save: [ Data@: FormList]
                        loop
                then    ; is doSaveAll

:NoName   { \ fname err - } \ compile all open forms to a single file
        #forms 2 < ?exit    \ no use merging 1 form
        \ we get the name of the merge file that will contain all forms
        GetFilter: SaveFormDlg new$ dup>r place
        s" Forms|*.frm|All Files|*.*|" SetFilter: SaveFormDlg
        GetHandle: TheMainWindow Start: SaveFormDlg to fname
        r> count SetFilter: SaveFormDlg
        fname c@ 0= ?exit       \ operation was cancelled
        \ add a default .frm extension if none specified
        fname count 2dup pad place ".ext-only" nip 0=
        if  s" .frm" pad +place
        then    pad count SetName: MergeFile
        Create: MergeFile ?exit
        \ now we compile all forms to memory and then write to merge file
        >FirstLink: FormList
        #forms 1+ 1
        do  Data@: FormList GetBuffer: [ ] 2drop
            +crlf +crlf     \ couple blank lines
            TheBuffer Write: MergeFile ?leave
            >NextLink: FormList
        loop    Close: MergeFile ClearName: MergeFile ;  is doMerge

:NoName   ( -- )       \ copy to clipboard
          ActiveForm 0= ?exit
          GetBuffer: ActiveForm copy-clipboard ;  is doCopy


:NoName   ( -- )       \ Copy Control List to Console	DB 2009-0427
          ActiveForm 0= ?exit
          TypeControlList: ActiveForm ;  is doCopyControlListConsole

:NoName   ( -- )       \ Copy Control List to Clipboard	DB 2009-0427
          ActiveForm 0= ?exit
          GetControlList: ActiveForm copy-clipboard ;  is doCopyControlListClipboard

:NoName   ( -- )       \ Copy Function List to Console	DB 2009-0502
          ActiveForm 0= ?exit
          TypeFunctionList: ActiveForm ;  is doCopyFunctionListConsole

:NoName   ( -- )       \ Copy Function List to Clipboard DB 2009-0502
          ActiveForm 0= ?exit
          GetFunctionList: ActiveForm copy-clipboard ;  is doCopyFunctionListClipboard

: CloseForm     { TheForm -- }
                SetFocus: TheForm
                Close: TheForm
                TheForm ?FormNumber >Link#: FormList
                TheForm Dispose
                0 Data!: FormList
                DeleteLink: FormList
                #Forms 0=
                if      Blank: Monitor
                        ForthFormTitle$ SetText: TheMainWindow
                        ClearStatusWindow
                        SetFocus: TheMainWindow
                        0 to ActiveForm
                        Close: frmProperties++
			Close:  frmFormFuncEdit
			Close:  frmFuncEdit
                        UpdateSystem
			FormList Dispose 0 to FormList
                else    SetFocus: [ Data@: FormList ]
                        ActiveControl: Activeform
                        if      UpdatePropertyWindow
                        then
                then
                UpdateFormPicker
                #Forms 2 <
                if      Close: frmCreatePropertyForm
                then    UpdateSystem
                ; ' CloseForm is doCloseForm

:NoName         ( -- )  \ clean slate
                FormList 0= ?exit
		>FirstLink: FormList
		Begin	      FormList
		While	      Data@: FormList doCloseForm
		Repeat	;  is doCloseAllForms

/*   ********************** Main ForthForm Window  *************** */

:Object MainWindow      <Super Window
MultiStatusbar controlstats    \ status window
create bardivisions 136 , 250 , 400 , 460 , -1 ,

\ BackGroundImage can be a bitmap or jpeg file, bitmap taking precedent
\ A file name specified in the configuration file overrides default
\ An image filename saved in the registry overrides all others
\ Search the directory that the program was loaded from
#IFDEF withbgnd
: GetBackGroundImage  ( -- addr cnt f ) \ return BackGroundImage filename, f=0=success
                BkGndImage$ c@    \ if set, check that it exists
                if      BkGndImage$ count 2dup file-status nip exit
                then    prognam>pad s" forthform.bmp" pad +place
                pad count 2dup file-status nip dup
                if      3drop s" jpg" pad count 3 - + swap move  \ just change extension
                        pad count 2dup file-status nip
                then    ;
#ENDIF

:M OriginX:     ( -- originx )
                originx ;M

:M OriginY:     ( -- originy )
                originy ;M

:M StartSize:   ( -- width height )
                WindowWidth WindowHeight
                ;M

:M StartPos:    ( -- x y )
                WindowLeft WindowTop
                ;M

:M MinSize:     ( -- w h )
                520 50 ;M

:M DefaultIcon: ( -- hIcon )  \ return the default icon handle for window
                LoadAppIcon ;M

: rebar_position     { \ h -- x y w h }
		height height: statuswindow - to h
                align_rebar top =
                if        0 0 width height: therebar exit
                then      align_rebar bottom =
                if        0 h height: therebar dup>r - width r> exit
                then      align_rebar left =
                if        0 0 Width: TheRebar h exit
                then      width Width: TheRebar dup>r - 0 r> h
                ;

:M Canvas:      { \ x y w h winw winh -- x y w h }
                rebar_position
                to h to w to y to x
		width height Height: statuswindow - to winh to winw
                align_rebar top =
                if        0 h winw winh h -  exitm
                then      align_rebar bottom =
                if        0 0 winw winh h - exitm
                then      align_rebar left =
                if        w 0 winw winh exitm
                then      ( align right ) 0 0 winw w - winh
                ;M

:M PositionRebar: ( -- )
                  rebar_position Move: TheRebar
                  ;M

:M On_Init:     ( -- )
                On_Init: super

                MainMenuBar SetMenubar: self

                ControlToolBar to TheControlToolBar
                MainToolBar to TheMainToolBar

                s" MS Sans Serif" SetFaceName: ControlFont
                8 Width: ControlFont
                Create: ControlFont

                self to TheMainWindow

                COLOR_BTNFACE Call GetSysColor NewColor: FormColor

#IFDEF withbgnd
                self Start: BkGndImageWindow
                FIT_SIZE SetViewMode: BkGndImageWindow
                GetBackGroundImage
                if      2drop     \ file wasn't found
                else    SetImageFile: BkGndImageWindow
                then
#ENDIF
                self Start: controlstats    \ set up status window
                Handle: ControlFont SetFont: controlstats
                Addr: controlstats to statuswindow
                bardivisions 5 SetParts: controlstats

                self Start: TheRebar

                ShowMonitor?
                if      Start: Monitor
                then

                ShowConsole?               \ display  Console 2008-07-14 DB
                if      doForth
                then

                \ create default bitmap handles for bitmap buttons
                PictureBitmap usebitmap   \ create bitmap handle
                GetDc: self dup>r CreateDIBitmap to picturebmp
                Static_Bitmap usebitmap
                r@ CreateDIBitmap to staticbmp
                r> ReleaseDc: self

                UpdateSystem

                InitScintillaControl    \ for the editor
                ;M

#IFDEF withbgnd
:M ReDrawImage: ( -- )
                Canvas: self Move: BkGndImageWindow ;M
#ENDIF

:M On_Size:     ( -- )
                AutoSize: ControlToolBar
                AutoSize: MainToolBar
                PositionRebar: self
\+ withbgnd     ReDrawImage: self
                Redraw: statuswindow
                SizeHelpWindow
		;M

: DefaultRebar  ( -- )
		align_rebar 1 and
		if   	RebarWidth
			if 	RebarWidth Height: TheRebar GetHandle: TheRebar AdjustWindowSize
			then	exit
		then	RebarHeight
		if      Width: TheRebar RebarHeight GetHandle: TheRebar AdjustWindowSize
		then	;

:m RestoreRebar:	( -- )
			DefaultRebar
			On_Size: self ;m

/*   ***************** Toolbar handlers *********************** */

:M WM_NOTIFY    { h m w l \ hwndfrom -- f }
                l @ to hwndfrom
                l 2 cells+ @  RBN_AUTOSIZE =   \ has TheRebar size changed?
                if
\+ withbgnd             RedrawImage: self
                        SizeHelpWindow
                then
                hwndfrom GetHandle: MainToolBar =
                hwndfrom ToolTipHandle: MainToolBar =  or
                if   w l Handle_Notify: MainToolBar
                else hwndfrom GetHandle: ControlToolBar =
                     hwndfrom ToolTipHandle: ControlToolBar = or
                     if    w l Handle_Notify: ControlToolBar
                     else  false
                     then
                then
                ;M

:M WndClassStyle: ( -- style )   CS_DBLCLKS ;M

: setnext       ( nexttype -- )
                to NextControlType true to newcontrol? ;

: ?TypeTextBox  ( --  type )
                ?control       \ control key pressed while buttonclicked?
                if      TypeMultiLineBox
                else    TypeTextBox
                then    ;

: ?TypeBitMapButton    ( -- type )	\ previously with Label DB 2009-0505
                ?control        \ control key pressed while buttonclicked?
                if      TypeStaticBitmap
                else    TypeBitMapButton
                then    ;

: ?TypeComboBox ( -- type )
                ?control         \ control key pressed while buttonclicked?
                if      TypeComboListBox
                else    TypeComboBox
                then    ;

: ?TypeListBox  ( -- type )
                ?control          \ control key pressed while buttonclicked?
                if      TypeMultiListBox
                else    TypeListBox
                then    ;

IDC_DRAWBOX to DrawBoxID        \ added DB 2010-0521

:M On_Command:  { hCtrl ncode id -- f }
                id dup to buttonid
                case
                        GetId: FormPicker of ncode CBN_SELCHANGE  =
                                               if       GetCurrent: FormPicker
                                                        1+ >Link#: FormList
                                                        Data@: FormList SetFocus: [ ]
                                               then                      endof
                        IDC_BITMAP         of   ?TypeBitMapButton setnext endof	\ ? previously with Label DB 2009-0505
                        IDC_LABEL          of   TypeLabel        setnext endof
                        IDC_TEXTBOX        of   ?TypeTextBox     setnext endof
                        IDC_GROUPBOX       of   TypeGroupBox     setnext endof
                        IDC_PUSHBUTTON     of   TypePushButton   setnext endof
                        IDC_CHECKBOX       of   TypeCheckBox     setnext endof
                        IDC_RADIOBUTTON    of   TypeRadioButton  setnext endof
                        IDC_COMBOBOX       of   ?TypeComboBox    setnext endof
                        IDC_LISTBOX        of   ?TypeListBox     setnext endof
                        IDC_HorizScroll    of   TypeHorizScroll  setnext endof
                        IDC_VertScroll     of   TypeVertScroll   setnext endof
                        IDC_Generic        of   TypeGeneric      setnext endof
                        IDC_FILEWINDOW     of   TypeFileWindow   setnext endof
                        IDC_TABCONTROL     of   TypeTabControl   setnext endof
                        IDC_DRAWBOX        of   TypeDrawBox      setnext endof
                        IDC_NEW            of   doNew                    endof
                        IDC_OPEN           of   doOpen                   endof
                        IDC_SAVE           of   doSave                   endof
                        IDC_HELP           of   doFormHelp               endof
                        IDC_DELETE         of   doDelete                 endof
                        IDC_COPY           of   doCopy                   endof
                        IDC_COMPILE        of   doWrite                  endof
                        IDC_TEST           of   doTest                   endof
                        IDC_BACK           of   doMoveToBack             endof
                        IDC_FRONT          of   doMoveToFront            endof
                        IDC_CONSOLE        of   doForth                  endof
                        IDC_TURNKEY        of   doTurnkey                endof \ changed from IDC_EDITOR DB 2009-0309
                        IDC_TAB            of   doTabOrder               endof
                        IDC_SAVEALL        of   doSaveAll                endof
                        IDC_LOADSESSION    of   doLoadSession            endof
                        IDC_SAVESESSION    of   doSaveSession            endof
                        0 to NextControlType false to newcontrol?
                endcase ;M

:M WM_COMMAND   ( hwnd msg wparam lparam -- res )
                ?dup 0=
                if      LOWORD
                        CurrentMenu
                        if      dup DoMenu: CurrentMenu
                        then
                        CurrentPopup
                        if      dup DoMenu: CurrentPopup
                        then    drop
                else    over HIWORD ( notification code ) rot LOWORD ( ID )
                        On_Command: [ self ]
                then
                0 ;M

:M On_Paint:    ( -- )
		0 0 GetSize: self Addr: BackGroundColor FillArea: dc	\ DB 2009-0507
\ \+ withbgnd     ReDrawImage: self
\                Canvas: self BackGroundColor FillArea: dc
                ;M

:M Close:       ( -- )
                SaveDefaults

                doCloseAllForms
                close-windows

                Close: super
                ;M

:M WindowTitle: ( -- title )
                ForthFormTitle$ asciiz ;M

:M On_SetFocus: ( -- )
                ClearStatusWindow
                ;M

:M WindowStyle: ( -- style )
                WindowStyle: super
                WS_CLIPCHILDREN or
                ;M

:M On_Done:     ( -- )
                MenuHandle: CurrentMenu ?dup
                if      Call DestroyMenu ?win-error  \ discard the menubar
                        ZeroMenu: CurrentMenu
                then    Delete: ControlFont
                picturebmp ?dup
                if      Call DeleteObject drop
                        0 to picturebmp
                then    staticbmp ?dup
                if      Call DeleteObject drop
                        0 to staticbmp
                then    ExitScintillaControl
\+ sysgen       0 Call PostQuitMessage
\+ sysgen       false vF-started                 \ set as no longer running
                100 ms 0 Call ExitProcess        \ added DB 2012-0414
                On_Done: super
                0 ;M

:M WindowHasMenu:       ( -- flag )
                true ;M

:M ClassInit:   ( -- )
                ClassInit: super
                ;M

:M WM_CLOSE     ( h m w l -- res )
                WM_CLOSE WM: Super
cr ." :Object MainWindow "
cr ." \+ sysgen       bye " key drop
\+ sysgen       bye
                0 ;M

:M WM_INITMENU  ( h m w l -- res )
                UpdateSystem
                0 ;M

:M WM_SYSCOLORCHANGE    ( h m w l -- res )
                RefreshForms
                DefaultWindowProc   \ update any other controls
                ;M

: answer_message   ( -- ) \ if file specified open it
                SetForegroundWindow: self
                param-buffer count ?dup
                if      OpenByExtension
                else    drop
                then    ;

: build-form-list   { \ tmp cnt -- }
                0 param-buffer !        \ default at no forms
                #Forms 0= ?exit
                0 to cnt                \ reset
                param-buffer cell+ to tmp
                #Forms 1+ 1
                ?do     i >Link#: FormList
                        TextFile: [ Data@: FormList ] dup 1+ cnt +
                        param-max > not                 \ don't exceed buffer
                        if      tuck tmp place 1+ +to cnt
                                1 param-buffer +!       \ increment form count
                                tmp count + to tmp
                        else    2drop
                        then
                loop    ;

: send-forms    ( -- )
                build-form-list 0 FORMS_SENT win32forth-message ;

comment:
:M Win32Forth:  ( h m w l -- )
                over case
                        FF_ACTIVATE      of   answer_message   endof
                        WANT_FORMS       of   send-forms       endof
                        Win32Forth: super
                      endcase
                0 ;M
comment;

:M PushKey:     ( c -- )
                case
                        'C' +k_control  of      doWrite         endof
                        'E' +k_control  of      doedit          endof
                        'F' +k_control  of      doForth         endof
                        'I' +k_control  of Start-Win32ForthIDE  endof
                        'N' +k_control  of      doNew           endof
                        'O' +k_control  of      doOpen          endof
                         K_F9           of   SetFocus: Monitor  endof
                         K_F12          of   ffLoadProject      endof
                         K_F1           of      doFormHelp      endof
                endcase ;M

;Object

create toolbar-reg$ MAXSTRING allot

: init-forthform ( -- ) \ initialization stuff for Forthform
                decimal
\in-system-ok   only forth also forthform also testvocab also definitions
                current-dir$ count 2dup SetDir: OpenFormDlg
                                   2dup SetDir: SaveFormDlg
                                   2dup SetDir: OpenSessionDlg
                                   2dup SetDir: SaveSessionDlg
                                   SetDir: GetBitmapDlg
                                   SetDir: GetMenuBarDlg     \ DB 2012-0414
                prognam>pad s" ForthForm.cfg" pad +place
                pad count file-status nip 0=         \ does it exist
                if pad ['] $fload catch drop    \ if so load it
                then

                set-base-path
                \ Set-up registry key for toolbar customization data...
                join$(  s" SOFTWARE\"
			PROGREG count
			s" Settings"
		)join$  1+ dup>r      \ Registry sub-key
                z" ControlToolBar" SetRegistryKey: ControlToolBar
                r> z" MainToolBar" SetRegistryKey: MainToolBar
                ;

: check-if-running ( -- )
                ed-ptr
                if      ?vF-started
                        if      CmdLine ?dup
                                if      strip-cmdline
                                else    drop pad 0
                                then    param-buffer place
                                0 FF_ACTIVATE win32forth-message
cr ." check-if-running bye " key drop
                                bye
                        else    true vF-started    \ set as running
                        then
                then    ;

: show-release-notes        ( -- ) \ show one time only
                    show-notes?
                    if    FormHelp	\ changed to FormHelp DB 2009 0617    
\ s" doc\FORTHform\visualFORTH.htm" help$ place
\                               (FormHelp)
                               \ false to show-notes?
                    then       ;

: FForm         ( -- )
\+ sysgen       check-if-running
                init-forthform
                LoadDefaults            \ read default settings in registry
                Start: Mainwindow
		RestoreRebar: MainWindow
\+ sysgen       HandleCmdLine  \ November 8th, 2003 - 9:52 dbu
                show-release-notes
\+ sysgen       z" visualFORTH Console" conhndl Call SetWindowText drop
                ;

also forth definitions

: EndvisualFORTH ( -- )      \ coming up second when starting visualFORTH
\ cr ." EndvisualFORTH " key drop	\ for testing purposes DB 2010-0612
	doCloseAllForms 
        false
        vF-started
        k_bye	
;

: StartvisualFORTH 
\ cr ." StartvisualFORTH " key drop	\ for testing purposes DB 2010-0612
	doCloseAllForms
	true
	vF-started
                ['] EndvisualFORTH is bye
                ['] FForm catch ExitOnError
	ShowConsole?
        0= if   hide-console
                SetFocus: MainWindow 
	   then
;


: vF            ( -- )    \ main executable word
                ['] StartvisualFORTH is bye
                ['] FForm catch ExitOnError ;

: Special-vF cr ." Special-vF " key drop vF ;
: End-vF cr ." End-vF " key drop vF ;

: save-vF       ( -- )    \ main executable word
\ cr ." save-vF " key drop	\ for testing purposes DB 2010-0612
                ['] StartvisualFORTH is bye  
                ['] FForm catch ExitOnError
;

: MENUCONSOLE-Exit-bye
cr ." MENUCONSOLE-Exit-bye " key drop bye
;



previous definitions

#IFNDEF sysgen

POPUPBAR ForthForm-Popup-bar
    POPUP " "
        MENUITEM        "&Copy Highlighted Text \tCtrl+C"  copy-console ;
        MENUITEM        "&Paste to Keyboard     \tCtrl+V"  paste-load ;
        MENUSEPARATOR
        MENUITEM        "&Mark all Text         \tCtrl+A"  mark-all ;
        MENUSEPARATOR
        MENUITEM        "&Form Designer"         Special-vF ;
        MENUITEM        "Win32 API Help" help-index ;
        MENUSEPARATOR
        MENUCONSOLE     "Exit"                  MENUCONSOLE-Exit-bye ;
ENDBAR

also hidden
ForthForm-Popup-bar Set-console-popup
previous
#ENDIF

0 value con
: ForthConsole  ( -- )
                inconsole dup 0= to inconsole
                if      hide-console
                        SetFocus: MainWindow
                else    con
                        if      show-console
                        else    normal-console  \ first time only
                                true to con
                                show-cursor
                        then    foreground-console
                then    ;


: DesignWindow  ( -- )
                inconsole dup 0= to inconsole
                if      SetFocus: MainWindow
                else    foreground-console
                then    ;


#IFDEF sysgen
' ForthConsole is doForth
#ELSE
' DesignWindow is DoForth
#ENDIF

' DesignWindow is doForthConsole




/* ********************** ForthForm Preferences **************** */
\ preferences.frm     \ preferences dialog

: ApplyPreferences ( -- )
                IsButtonChecked?: chkFlatToolBar to FlatToolBar?
                IsButtonChecked?: chkShowMonitor  to ShowMonitor?
                IsButtonChecked?: chkConsole to ShowConsole? doForth   \ display  Console 2008-07-14 DB 
                IsButtonChecked?: chkShowReleaseNotes to show-notes?
                IsButtonChecked?: chkZooming dup to Zooming? zooming !	\ added 2010-0503 DB
                IsButtonChecked?: radAlignTop    if top    then
                IsButtonChecked?: radAlignBottom if bottom then
                IsButtonChecked?: radAlignLeft   if left   then
                IsButtonChecked?: radAlignRight  if right  then
		to align_rebar
		rebar$ off	\ start fresh
                Close: TheReBar
                TheMainWindow Start: TheRebar
                PositionRebar: TheMainWindow
\+ withbgnd     ReDrawImage: TheMainWindow
                ?ShowMonitor
                UpdateSystem
                ;


: pref-func     { id obj -- }  ( h m w l id obj -- h m w l )
                id
                case    IDOK            of      ApplyPreferences Close: obj   endof
                        IDCANCEL        of      Close: obj                    endof
                endcase ;




:NoName         ( -- )
                ['] pref-func SetCommand: frmPreferences
                GetHandle: TheMainWindow SetParentWindow: frmPreferences
                IDOK SetID: btnOk
                IDCANCEL SetID: btnCancel
                Start: frmPreferences
                Disable: chkButtonText
		Disable: chkCopyCodeClp
                FlatToolbar?  Check: chkFlatToolBar
                ShowMonitor?  Check: chkShowMonitor
                ShowConsole?  Check: chkConsole  \ display  Console 2008-07-14 DB
                show-notes?   Check: chkSHowReleaseNotes
                Zooming?      Check: chkZooming  \ added 2010-0503 DB
                align_rebar
                case
                    top       of     CheckButton: radAlignTop          endof
                    bottom    of     CheckButton: radAlignBottom       endof
                    left      of     CheckButton: radAlignLeft         endof
                    right     of     CheckButton: radAlignRight        endof
                endcase  ; is doPref
/* ************************************************************************* */


:NoName       ( -- )  \ shutdown
                Close: MainWindow
\ cr ." NoName "		\ for testing purposes DB 2010-0612
\ cr ." \+ sysgen       bye "	\ for testing purposes DB 2010-0612
\ cr ." ; is doExit " key drop	\ for testing purposes DB 2010-0612
\+ sysgen       bye
                ; is doExit

\ Session file loading definitions
\ A session file is a standard text file defining the current state of the system
\ To add any new status information simply define words for reading and writing it
#IFDEF withbgnd
: BackGroundImage=    ( <name> -- )   \ get BackGroundImage filename from input stream
                0 word dup c@
                if      count SetImageFile: BkGndImageWindow
                else    drop
                then    ;  ' BackGroundImage= alias WallPaper=
#ENDIF


: Form=         ( <name> -- )   \ get form filename from input stream
                0 word dup c@
                if      count (OpenForm)    \ if we have a form open it
                else    drop
                then    ;


: ?addext       { fname -- fname }
                fname c@
                if      fname count ".ext-only" nip 0=
                        if      s" .ses" fname +place
                        then
                then    fname ;
handle sfile


:NoName   	( -- )
                GetHandle: TheMainWindow Start: OpenSessionDlg dup c@
                if      nostack1 ['] $fload catch
                        s" Session load aborted!" ?MessageBox
                else    drop
                then    ; is doLoadsession

: ?write-error  ( f -- ) \ if flag is true display message and close file
                if      true s" Error writing session file!" ?MessageBox
                        sfile close-file drop
                then    ;

#IFDEF withbgnd
: write-BkGndImage ( -- f ) \ if we have an image file BackGroundImage write it, f=true=error
                  ImageFilename: BkGndImageWindow ?dup
                  if      s" BackGroundImage= " sfile write-file >r
                          sfile write-line r> or dup ?write-error
                  else  drop false    \ no error
                  then  ;
#ENDIF


: write-formfiles { \ err -- f } \ write any forms opened, f=true=error,
                  0 to err
                  #Forms ?dup
                  if    >FirstLink: FormList
                        1+ 1
                        do      s" Form= " sfile write-file >r
                                Data@: FormList GetFileName: [ ]
                                sfile write-line r> or dup to err ?leave
                                >NextLink: FormList
                        loop
                  then  err dup ?write-error ;


:NoName   ( -- )  \ save current state of system
                GetHandle: TheMainWindow Start: SaveSessionDlg ?addext count ?dup
                if      r/w create-file swap to sfile dup ?write-error ?exit     \ create
                        write-formfiles ?exit       \ do this first so that if we try loading a session
\+ withbgnd             write-BkGndImage ?exit      \ with an invalid background image, the forms will still load
                        sfile close-file drop
                else    drop
                then    ;   is doSaveSession


only forth also definitions

#IFDEF sysgen           \ if we are turnkeying
        warning off     \ we know we are redefining
        mark empty      \ protect our dictionary
        warning on      \ as we were
#ENDIF


\ According to the Windows API if the extension is not specified the following
\ will fail. Strangely enough it works in Win32Forth...but not always.

\+ sysgen       s" %DIRWin32ForthIDE.exe %FILENAME %LINE" editor$ place


\+ sysgen       s" %DIRWin32ForthIDE.exe /B %FILENAME %LINE" browse$ place


\+ sysgen &forthdir count &appdir place \ create visualForth.exe in the Win32Forth directory


\+ sysgen 0 0 ' save-vF save visualForth.exe   \ coming up first when starting visualFORTH

\  application changed to save DB 2010-0606



forthform also
\ add the Application Icon to the resource of the exe-file if possible
\+ sysgen s" src\res\visualFORTH.ico" s" visualForth.exe" Prepend<home>\ AddAppIcon


\+ sysgen previous


\+ sysgen 1 pause-seconds bye    \ this is the end of a metacompilation 


\- sysgen  End-vF


\s
That's all folks!
