; $Id: Win32Forth.nsi,v 1.14.2.2 2013/08/14 18:04:30 georgeahubert Exp $

; NSIS (Nullsoft Scriptable Installation System) Script for Win32Forth.
; Script generated with the Venis Install Wizard and edited by Dirk Busch.
; see http://nsis.sf.net for details about the installer.

; Define your application version
!define VER_MAJOR          6
!define VER_MINOR         14
!define VER_REVISION      04
!define VER_DISPLAY       "6.14.04"
!define VER_FILE          "61404"

; Define your application name
!define APPNAME              "Win32Forth"
!define APPNAMEANDVERSION    "${APPNAME} ${VER_DISPLAY}"

!define PUBISHER       		"Win32Forth Project Group"
!define PROJECT_URL				"http://www.win32forth.org/"
!define HELP_URL					"http://groups.yahoo.com/group/win32forth/"

; Main Install settings
Name             "${APPNAMEANDVERSION}"
; InstallDir       "$PROGRAMFILES\${APPNAMEANDVERSION}"
InstallDir       "c:\${APPNAMEANDVERSION}"
InstallDirRegKey HKLM "Software\${APPNAMEANDVERSION}" ""
OutFile          "w32f${VER_FILE}.exe"
SetCompress      "force"
SetCompressor    "LZMA"

Function CompileW32f
	MessageBox MB_OK|MB_ICONINFORMATION "Now the complete Win32Forth system will be rebuild. Please wait until it's finished." 
	ExecWait '"$INSTDIR\Setup.EXE" true install-silent'
FunctionEnd

Function AssociateFileExtentions
;	MessageBox MB_YESNO|MB_ICONQUESTION "Should the file extention .F be associated with 'WinEd'?" IDNO AFE1
;	WriteRegStr HKCR ".f" "" "f_auto_file"
;	WriteRegStr HKCR "f_auto_file" "" "${APPNAME} Sourcefile"
;	WriteRegStr HKCR "f_auto_file\shell" "" "open"
;	WriteRegStr HKCR "f_auto_file\shell\open\command" "" '"$INSTDIR\WinEd.exe" "%1"'
AFE1:
;	MessageBox MB_YESNO|MB_ICONQUESTION "Should the file extention .F be associated with 'SciEdit'?" IDNO AFE2
;  WriteRegStr HKCR ".f" "" "f_auto_file"
;  WriteRegStr HKCR "f_auto_file" "" "${APPNAME} Sourcefile"
;  WriteRegStr HKCR "f_auto_file\shell" "" "open"
;  WriteRegStr HKCR "f_auto_file\shell\open\command" "" '"$INSTDIR\SciEditMdi.EXE" "%1"'
AFE2:
	MessageBox MB_YESNO|MB_ICONQUESTION "Should the file extention .F be associated with the 'Win32Forth IDE'?" IDNO AFE3
  WriteRegStr HKCR ".f" "" "f_auto_file"
  WriteRegStr HKCR "f_auto_file" "" "${APPNAME} Sourcefile"
  WriteRegStr HKCR "f_auto_file\shell" "" "open"
  WriteRegStr HKCR "f_auto_file\shell\open\command" "" '"$INSTDIR\Win32ForthIDE.EXE" "%1"'
AFE3:
;	MessageBox MB_YESNO|MB_ICONQUESTION "Should the file extention .FF be associated with 'visualFORTH'?" IDNO AFE4
; WriteRegStr HKCR ".ff" "" "ff_auto_file"
; WriteRegStr HKCR "ff_auto_file" "" "${APPNAME} Form"
; WriteRegStr HKCR "ff_auto_file\shell" "" "open"
; WriteRegStr HKCR "ff_auto_file\shell\open\command" "" '"$INSTDIR\visualFORTH.exe" "%1"'
AFE4:
;	MessageBox MB_YESNO|MB_ICONQUESTION "Should the file extention .FPJ be associated with 'ProjectManager'?" IDNO AFE5
;	WriteRegStr HKCR ".fpj" "" "fpj_auto_file"
;	WriteRegStr HKCR "fpj_auto_file" "" "${APPNAME} Projectfile"
;	WriteRegStr HKCR "fpj_auto_file\shell" "" "open"
;	WriteRegStr HKCR "fpj_auto_file\shell\open\command" "" '"$INSTDIR\Project.exe" "%1"'
AFE5:
	MessageBox MB_YESNO|MB_ICONQUESTION "Should the file extention .FPJ be associated with the 'Win32Forth IDE'?" IDNO AFE6
	WriteRegStr HKCR ".fpj" "" "fpj_auto_file"
	WriteRegStr HKCR "fpj_auto_file" "" "${APPNAME} Projectfile"
	WriteRegStr HKCR "fpj_auto_file\shell" "" "open"
	WriteRegStr HKCR "fpj_auto_file\shell\open\command" "" '"$INSTDIR\Win32ForthIDE.exe" "%1"'
AFE6:
FunctionEnd

; Modern interface settings
!include "MUI.nsh"

!define MUI_ABORTWARNING
!define MUI_FINISHPAGE_RUN "$INSTDIR\Win32For.EXE"
!define MUI_ICON           "..\..\..\win32forth\src\res\Win32For.ico"
!define MUI_UNICON         "..\..\..\win32forth\src\res\Win32For.ico"

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!define MUI_WELCOMEFINISHPAGE_CUSTOMFUNCTION_INIT CompileW32f
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Set languages (first is default language)
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_RESERVEFILE_LANGDLL

Section "Win32Forth" Section1

	; Set Section properties
	SetOverwrite on

	; Set Section Files
	!include "Files.nsi"

	; Set Shortcuts
  SetOutPath $INSTDIR ; for working directory
	CreateShortCut "$DESKTOP\Win32Forth.lnk" "$INSTDIR\Win32for.EXE" "" "$INSTDIR\src\res\Win32for.ico" "" "" "" "Win32Forth Console"
;	CreateShortCut "$DESKTOP\WinEd.lnk" "$INSTDIR\WinEd.EXE" "" "$INSTDIR\src\res\WinEd.ico" "" "" "" "Win32Forth Editor"
	CreateShortCut "$DESKTOP\visualFORTH.lnk" "$INSTDIR\visualFORTH.EXE" "" "$INSTDIR\src\res\visualFORTH.ico" "" "" "" "Win32Forth Dialog-Editor"
;	CreateShortCut "$DESKTOP\ForthProject.lnk" "$INSTDIR\Project.EXE" "" "$INSTDIR\src\res\Project.ico" "" "" "" "Win32Forth Project Manager"
;	CreateShortCut "$DESKTOP\SciEdit.lnk" "$INSTDIR\SciEditMdi.EXE" "" "$INSTDIR\src\res\SciEditMDI.ico" "" "" "" "Win32Forth SciEdit"
	CreateShortCut "$DESKTOP\Win32ForthIDE.lnk" "$INSTDIR\Win32ForthIDE.EXE" "" "$INSTDIR\src\res\SciEditMDI.ico" "" "" "" "Win32Forth IDE"
;	CreateShortCut "$DESKTOP\Win32Forth Setup.lnk" "$INSTDIR\Setup.EXE" "" "$INSTDIR\src\res\Win32for.ico" "" "" "" "Win32Forth Setup"
	CreateShortCut "$DESKTOP\Win32ForthHelp.lnk" "$INSTDIR\Help.EXE" "" "$INSTDIR\src\res\Win32for.ico" "" "" "" "Win32Forth Help"
	
	CreateDirectory "$SMPROGRAMS\${APPNAMEANDVERSION}"
	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Win32Forth.lnk" "$INSTDIR\Win32for.EXE" "" "$INSTDIR\src\res\Win32for.ico" "" "" "" "Win32Forth Console"
;	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\WinEd.lnk" "$INSTDIR\WinEd.EXE" "" "$INSTDIR\src\res\WinEd.ico" "" "" "" "Win32Forth Editor"
;	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\SciEdit.lnk" "$INSTDIR\SciEditMdi.EXE" "" "$INSTDIR\src\res\SciEditMDI.ico" "" "" "" "Win32Forth SciEdit"
	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Win32ForthIDE.lnk" "$INSTDIR\Win32ForthIDE.EXE" "" "$INSTDIR\src\res\SciEditMDI.ico" "" "" "" "Win32Forth IDE"
	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\visualFORTH.lnk" "$INSTDIR\visualFORTH.EXE" "" "$INSTDIR\src\res\visualFORTH.ico" "" "" "" "Win32Forth Dialog-Editor"
;	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\ForthProject.lnk" "$INSTDIR\Project.EXE" "" "$INSTDIR\src\res\Project.ico" "" "" "" "Win32Forth Project Manager"
	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Setup.lnk" "$INSTDIR\Setup.EXE" "" "$INSTDIR\src\res\Win32for.ico" "" "" "" "Win32Forth Setup"
;	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Documentation.lnk" "$INSTDIR\doc\p-index.htm"
	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Uninstall.lnk" "$INSTDIR\uninstall.exe"
;	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Release notes.lnk" "$INSTDIR\doc\p-relnotes.6.12.htm"
	CreateShortCut "$SMPROGRAMS\${APPNAMEANDVERSION}\Win32ForthHelp.lnk" "$INSTDIR\Help.EXE"

	WriteINIStr "$SMPROGRAMS\${APPNAMEANDVERSION}\${PUBISHER}.url" "InternetShortcut" "URL" "${PROJECT_URL}"
  WriteINIStr "$SMPROGRAMS\${APPNAMEANDVERSION}\Win32Forth Forum.url" "InternetShortcut" "URL" "${HELP_URL}"

SectionEnd

Section "ExtSrc" Section2

	; Set Section properties
	SetOverwrite on

	; Set Section Files
	!include "ExtFiles.nsi"

SectionEnd

Section -FinishSection

	; write Registry entries
	!include Registry.nsi

	; save Install directory
	WriteRegStr 	HKLM "Software\${APPNAMEANDVERSION}" "" "$INSTDIR"

	; setup the uninstaller
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "DisplayName" 		"${APPNAMEANDVERSION}"
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "DisplayIcon" 		"$INSTDIR\src\res\Win32for.ico,0"
	WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "Publisher" 			"${PUBISHER}"
	WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "UninstallString" "$INSTDIR\uninstall.exe"
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "InstallLocation" "$INSTDIR"
	WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "URLUpdateInfo"		"${PROJECT_URL}"
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "URLInfoAbout" 		"${PROJECT_URL}"
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "HelpLink " 			"${HELP_URL}"
  WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "DisplayVersion" 	"${VER_DISPLAY}"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "VersionMajor" 		"${VER_MAJOR}"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "VersionMinor" 		"${VER_MINOR}.${VER_REVISION}"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "NoModify" 				"1"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}" "NoRepair" 				"1"

	WriteUninstaller "$INSTDIR\uninstall.exe"

	; register File extentions
	Call AssociateFileExtentions
	
SectionEnd

; Modern install component descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${Section1} "Win32Forth"
	!insertmacro MUI_DESCRIPTION_TEXT ${Section2} "Sources for the DLL's and the Installer of Win32Forth. Normaly not needed."
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;Uninstall section
Section Uninstall

	;Remove from registry...
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAMEANDVERSION}"
	DeleteRegKey HKLM "SOFTWARE\${APPNAMEANDVERSION}"
	DeleteRegKey HKCU "SOFTWARE\${APPNAMEANDVERSION}"
  DeleteRegKey HKCR ".f"
  DeleteRegKey HKCR "f_auto_file"
  DeleteRegKey HKCR ".ff"
  DeleteRegKey HKCR "ff_auto_file"
  DeleteRegKey HKCR ".fpj"
  DeleteRegKey HKCR "fpj_auto_file"

	; Delete self
	Delete "$INSTDIR\uninstall.exe"

	; Delete Shortcuts
	Delete "$DESKTOP\Win32Forth.lnk"
;	Delete "$DESKTOP\WinEd.lnk"
	Delete "$DESKTOP\visualFORTH.lnk"
;	Delete "$DESKTOP\ForthProject.lnk"
;	Delete "$DESKTOP\Win32Forth Setup.lnk"
;	Delete "$DESKTOP\SciEdit.lnk"
	Delete "$DESKTOP\Win32ForthIDE.lnk"
	Delete "$DESKTOP\Win32ForthHelp.lnk"

	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\Win32Forth.lnk" 
;	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\WinEd.lnk"
;	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\SciEdit.lnk"
	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\visualFORTH.lnk"
;	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\ForthProject.lnk"
	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\Setup.lnk"
;	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\Documentation.lnk"
	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\Uninstall.lnk"
;	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\Release notes.lnk"
	Delete "$SMPROGRAMS\${APPNAMEANDVERSION}\Win32ForthHelp.lnk"
  RMDir /r "$SMPROGRAMS\${APPNAMEANDVERSION}"

	; Delete Files and Folders 
  !include "Uninstall.nsi"

SectionEnd

BrandingText "${PUBISHER}"

; eof