\ source: FileEmit.f by BERTRAND Andr Jacques
\ ************************************************************
\ Switches console screen Inputs (key and key?) towards a form
\ ************************************************************
\ DB 2009-0323 - 2009-0411

\ Redirection Word: IsInput 

anew -FormKey.f

\ needs TextboxEmit.f

\ 0 value Form-Output	\ Key-Output of Form, defined for Kernel in Console2.f
0 value Input		\ destination of input

 internal

variable oKEY
variable oKEY?


: ClearKeydirection ( -- )
		false to Input
		oKEY off oKEY? off ;

ClearKeydirection \ clear it now...

: Keydirection?	( -- f )
		oKey @ 0<> ;

: SaveKeydirection ( -- )
		Keydirection? not \ only once
		if   defer@ KEY    oKEY    !
		     defer@ KEY?   oKEY?   !
		then ;


: SetKeydirection ( KEY_XT KEY?_XT )
		is KEY? is KEY ;

: RestoreKeydirection ( -- )
		Keydirection? 
		if   oKEY @ oKEY? @ SetKeydirection BL to Form-Output
		     ClearKeydirection
		then ;

Create KeyTable
ascii + c, ascii - c, ascii * c, ascii / c, 
ascii ! c, ascii @ c, ascii # c, ascii < c, ascii ( c, 
ascii { c, ascii } c, ascii ) c, ascii > c, ascii = c, 
ascii : c, ascii ; c, ascii . c, ascii " c, ascii ? c, 
ascii ' c, 

: TableKey 	( n -- char )
	KeyTable + c@
;

: AdjustKey	( n -- char )
	dup 58 = if   drop ascii 0 then
	dup 84 > if   85 - TableKey
		 else dup 58 > if ascii A 59 - + then
		 then 
;



: FormButton>Key? 	( -- char )
		Form-Output AdjustKey
;

variable FirstKey



: QueueKey>Form-Output		( -- )
   Maxstring 0 do KeyButtonQueue i + dup c@ ?dup 
			if   to Form-Output 0 swap c! leave
			else drop
			then loop
;

: FormButton>Key	( -- char )
		Begin winpause
		      Form-Output 0=
			if   QueueKey>Form-Output Form-Output
			else Form-Output AdjustKey
			then ?dup
		until
		0 to Form-Output
		FirstKey @ 0= if drop FirstKey on 10 then 
;

: >FormButton		( -- ) \ switches console Input to a FormButton only
		Input              \ (Input must be set)
		if   SaveKeydirection
		     ['] FormButton>Key ['] FormButton>Key?
		     SetKeydirection 
		then ;

external

: IsInput	( flag -- )	\ Form is input if flag is true
	0 to Form-Output
	Firstkey off ClearKeyButtonQueue
	to Input 
	>FormButton
;

: >console	( -- ) \ switches back to normal output
		RestoreKeydirection ;




FORTH module

